	PROGRAM PLTTIM

C
C	COPYRIGHT (C) 1979
C		MANAGEMENT SCIENCE ASSOCIATES, INC.
C		5100 CENTRE AVENUE
C		PITTSBURGH, PENNSYLVANIA  15232
C
C	THIS SOFTWARE IS DISTRIBUTED WITHOUT COST, AND MAY BE
C	REPRODUCED ONLY WITH THE INCLUSION OF THIS COPYRIGHT
C	STATEMENT.  MANAGEMENT SCIENCE ASSOCIATES ASSUMES NO
C	RESPONSIBILITY FOR THE PERFORMANCE OF THIS SOFTWARE.
C

C
C	MAIN PROGRAM FOR PLOTTING PERCENT CPU TIME USED
C
C	REQUIRES ROUTINES GETDAT AND PLTPNT (APPENDED)
C	REQUIRES QUADWORD ARITHMETIC PROCEDURES
C		QUAADD,QUASUB,QUAMUL,QUADIV,QUACMP
C			(SOURCE IN "QUAMTH.MAR")
C
C	NOTE: WHEN THE SYSTEM IS CRASHED, THE PROCESS THAT CREATES
C	THE STATISTICS USED HERE (PROCESS NULTIM) CANNOT RECORD DATA.
C	THIS PROGRAM IS NOT PARTICULARLY INTELLIGENT REGARDING THIS,
C	AND WILL REGARD SUCH PERIODS AS HAVING 100% USAGE.  SUCH
C	SPIKES IN THE PLOT ARE EASILY DISTINGUISHED, THOUGH NOT
C	AESTHETICALLY PLEASING.
C
	IMPLICIT INTEGER (A-Z)
	LOGICAL FIN
	CHARACTER*80 STRING
	CHARACTER*10 DEFFIL
	DIMENSION STRTIM(2),TIMINC(2),TIMMUL(2),ENDTIM(2),NXTTIM(2)
	DIMENSION FACTOR(2),DELCPU(2),DELWAL(2),RATE(2),T(2),C(2)
	DIMENSION LAST(3),THIS(3)
C
	DATA DEFFIL/'SYS$OUTPUT'/
	DATA DEFFLN/10/
	DATA DEFINC/1440/
	DATA MININC/30/
	DATA TFUDGE/99/
	DATA TIMMUL/10000000,0/
C
C	OPEN THE DATA FILE AND GET STARTING TIME
	CALL GETDAT(LAST,THIS,FIN)
	IF(FIN) GOTO 990
C
C	SAY THE STARTING TIME AND GET USER'S CHOICE
	STRLEN=0
	STRTIM(1)=THIS(1)
	STRTIM(2)=THIS(2)
	CALL SYS$ASCTIM(STRLEN,%DESCR(STRING),STRTIM,0)
	WRITE(6,1) STRING(1:STRLEN)
1	FORMAT(' ENTER DATE AND TIME TO START (DEFAULT = ',
	1	A,')'/' > '$)
	READ(5,2) STRLEN,STRING
2	FORMAT(Q,A)
	IF(STRLEN.LE.0) GOTO 100
	STS=SYS$BINTIM(%DESCR(STRING(1:STRLEN)),STRTIM)
	IF(.NOT.STS) GOTO 900
	IF(QUACMP(THIS,STRTIM).GT.0) GOTO 910
C
C	GET TIME INCREMENT
100	CONTINUE
	WRITE(6,3) DEFINC
3	FORMAT(' ENTER TIME INCREMENT IN SECONDS (DEFAULT = ',
	1	I4,')'/' > '$)
	READ(5,4) TIMINC(1)
4	FORMAT(I)
	TIMINC(2)=0
	IF(TIMINC(1).EQ.0) TIMINC(1)=DEFINC
	IF(TIMINC(1).LT.MININC) GOTO 920
	CALL QUAMUL(TIMINC,TIMMUL,TIMINC)
C
C	GET ENDING TIME
	STRLEN=0
	ENDTIM(1)=-1
	ENDTIM(2)='7FFFFFFF'X
	WRITE(6,5)
5	FORMAT(' ENTER ENDING DATE AND TIME (DEFAULT IS DATA EOF)',
	1	/' > '$)
	READ(5,6) STRLEN,STRING
6	FORMAT(Q,A)
	IF(STRLEN.LE.0) GOTO 200
	STS=SYS$BINTIM(%DESCR(STRING(1:STRLEN)),ENDTIM)
	IF(.NOT.STS) GOTO 900
	IF(QUACMP(STRTIM,ENDTIM).GE.0) GOTO 930
C
C	GET FUDGE FACTOR FOR CPU TO WALL TIME
200	CONTINUE
	WRITE(6,7) TFUDGE
7	FORMAT(' ENTER WALL TO CPU CONVERSION PERCENT (DEFAULT = ',
	1	I2,')'/' > '$)
	READ(5,8) FACTOR(1)
8	FORMAT(I)
	FACTOR(2)=0
	IF(FACTOR(1).EQ.0) FACTOR(1)=TFUDGE
	IF(FACTOR(1).LT.90.OR.FACTOR(1).GT.100) GOTO 940
	FACTOR(1)=1000000000/FACTOR(1)
C
C	GET THE OUTPUT FILE
	STRLEN=0
	WRITE(6,9) DEFFIL(1:DEFFLN)
9	FORMAT(' ENTER PLOT OUTPUT FILE SPEC (DEFAULT = ',
	1	A,')'/' > '$)
	READ(5,10) STRLEN,STRING
10	FORMAT(Q,A)
	IF(STRLEN.GT.0) GOTO 250
	STRING=DEFFIL
	STRLEN=DEFFLN
250	CONTINUE
	OPEN(UNIT=2,NAME=STRING(1:STRLEN),TYPE='NEW',ERR=950)
C
C	LOOK FOR GOOD STARTING PLACE
300	CONTINUE
	CALL GETDAT(LAST,THIS,FIN)
	IF(FIN) GOTO 1000
	IF(QUACMP(LAST,ENDTIM).GT.0) GOTO 1000
	IF(QUACMP(THIS,STRTIM).LE.0) GOTO 300
C
C	NOW HAVE LAST .LE. STRTIM .LT. THIS  -  SAVE IT
400	CONTINUE
	T(1)=LAST(1)
	T(2)=LAST(2)
	C(1)=LAST(3)
C
C	FIND NEXT TIME PARTITION
	IF(QUACMP(STRTIM,ENDTIM).GE.0) GOTO 1000
	CALL QUAADD(STRTIM,TIMINC,NXTTIM)
C
C	FIND POINT JUST BEFORE NEXT PARTITION
500	CONTINUE
	IF(QUACMP(THIS,NXTTIM).GT.0) GOTO 600
	CALL GETDAT(LAST,THIS,FIN)
	IF(FIN) GOTO 1000
	GOTO 500
C
C	NOW HAVE LAST .LE. NXTTIM .LT. THIS  -  COMPUTE CHANGE
600	CONTINUE
	C(1)=LAST(3)-C(1)
	IF(C(1).LT.0) C(1)=0
	C(2)=0
	CALL QUAMUL(C,FACTOR,DELCPU)
	CALL QUASUB(LAST,T,DELWAL)
	CALL QUADIV(DELCPU,DELWAL,RATE)
C
C	NOW PLOT THE POINT
	IF(RATE(1).LT.0) RATE(1)=0
	IF(RATE(1).GT.100) RATE(1)=100
	RATE(1)=100-RATE(1)
	CALL PLTPNT(STRTIM,RATE)
C
C	MOVE FORWARD A STEP AND LOOP
	STRTIM(1)=NXTTIM(1)
	STRTIM(2)=NXTTIM(2)
	GOTO 400
C
C	ERROR REPORTING
C
900	CONTINUE
	WRITE(6,901)
901	FORMAT(/' %BAD TIME SPECIFICATION')
	GOTO 1000
C
910	CONTINUE
	WRITE(6,911)
911	FORMAT(/' %CAN''T START BEFORE DATA DOES')
	GOTO 1000
C
920	CONTINUE
	WRITE(6,921)
921	FORMAT(/' %TIME INCREMENT TOO TINY')
	GOTO 1000
C
930	CONTINUE
	WRITE(6,931)
931	FORMAT(/' %MUST END AFTER START')
	GOTO 1000
C
940	CONTINUE
	WRITE(6,941)
941	FORMAT(/' %THAT''S AN UNREASONABLE FACTOR')
	GOTO 1000
C
950	CONTINUE
	WRITE(6,951)
951	FORMAT(/' %CAN''T OPEN THE PLOT FILE')
	GOTO 1000
C
990	CONTINUE
	WRITE(6,991)
991	FORMAT(/' %CAN''T FIND THE DATA BASE')
	GOTO 1000
C
C	FIN
1000	CONTINUE
	STOP
	END
C
C	GETDAT - ROUTINE TO READ THE TIME FILE FROM UNIT 1
C
	SUBROUTINE GETDAT(LAST,THIS,FIN)
	IMPLICIT INTEGER (A-Z)
	DIMENSION LAST(3),THIS(3)
	DIMENSION RECORD(384)
	DIMENSION CHUNK(3,0:127)
	INTEGER WHERE
	LOGICAL FIN
	EQUIVALENCE (RECORD(1),CHUNK(1,0))
	DATA WHERE/-1/
C
	IF(WHERE) 100,200,300
C
C	INITIALIZATION
100	CONTINUE
	FIN=.FALSE.
	THIS(1)=0
	THIS(2)=0
	THIS(3)=0
	OPEN(UNIT=1,NAME='DBA0:[SYSMGR]NULTIM.DAT',TYPE='OLD',
	1	READONLY,RECORDTYPE='FIXED',RECORDSIZE=384,
	2	FORM='UNFORMATTED',SHARED)
	WHERE=0
C
C	FETCH A NEW RECORD
200	CONTINUE
	READ(1,END=400) RECORD
C
C	RETRIEVE THE DATA, MOVING PREVIOUS ONE TO LAST
300	CONTINUE
	DO 310 I=1,3
	LAST(I)=THIS(I)
	THIS(I)=CHUNK(I,WHERE)
310	CONTINUE
	WHERE=MOD(WHERE+1,128)
	RETURN
C
C	END OF FILE
400	CONTINUE
	CLOSE(UNIT=1)
	FIN=.TRUE.
	DO 410 I=1,3
	LAST(I)=THIS(I)
	THIS(I)=0
410	CONTINUE
	RETURN
	END
C
C	PLTPNT - PLOT A POINT ON UNIT 2
C
	SUBROUTINE PLTPNT(TIME,VALUE)
	IMPLICIT INTEGER (A-Z)
	DIMENSION TIME(2)
	CHARACTER*115 OUTSTR
	CHARACTER*103 STRING1,STRING2
	CHARACTER*11 TIMSTR
	INTEGER LINNUM
C
	DATA STRING1/' +         +         +         +         +         +
	1         +         +         +         +         +'/
	DATA STRING2/' |**************************************************
	1**************************************************'/
	DATA LINNUM/0/
C
	IF(LINNUM.GT.0) GOTO 100
C
C	WRITE THE HEADER STUFF
	CALL SYS$ASCTIM(,%DESCR(TIMSTR),%REF(TIME),%VAL(0))
	WRITE(2,10) TIMSTR
10	FORMAT('1  VAX - PERCENT CPU TIME USED - ',A,
	1	//13X,'0',44X,'PERCENTAGE',44X,'100'/)
	GOTO 200
C
C	CHECK FOR AXIS TYPE
100	CONTINUE
	IF(MOD(LINNUM,10).EQ.0) GOTO 200
C
C	NO GAMES WITH THE AXIS
	OUTSTR='            '//STRING2(1:VALUE+2)
	OUTLEN=VALUE+15
	GOTO 300
C
C	AXES TICKS IN THIS ONE
200	CONTINUE
	CALL SYS$ASCTIM(,%DESCR(TIMSTR),%REF(TIME),%VAL(1))
	OUTSTR=' '//TIMSTR//STRING2(1:VALUE+2)//STRING1(VALUE+3:103)
	OUTLEN=115
C
C	WRITE THE STRING
300	CONTINUE
	WRITE(2,20) OUTSTR(1:OUTLEN)
20	FORMAT(A)
	LINNUM=LINNUM+1
	RETURN
	END
