C	************************ PMEBUILD MAINLINE ****************************
C
C
	PROGRAM PMEBUILD
C
C
C	THE PMEBUILD PROGRAM BUILDS AN INITIAL, EMPTY BUCKET FILE.  TO DO SO,
C	IT READS IN THE PROGRAM UNIT DEFINITION FILE, CONSTRUCTS A TABLE OF
C	ALL PROGRAM UNITS, PROCESSES ALL ADDRESS DEFINITIONS (GETTING THE DATA
C	FROM THE DEFINITION FILE, THE LINK MAP, OR THE TRACEBACK INFORMATION
C	IN THE EXECUTABLE IMAGE), AND PRODUCES A BUCKET FILE BASED ON THE
C	SPECIFIED SAMPLING DEFINITIONS.
C
C
C			WRITTEN BY BERT BEANDER, MARCH, 1979.
C
C
C	***DATA DEFINITIONS
	INCLUDE 'PMECOMMON.FOR/LIST'
	INCLUDE 'PMECOMDEF.FOR/LIST'
C
	DIMENSION KINDSTK(0:MAXKINDS)
	CHARACTER*16 PSECTNAME, UNITNAME
	CHARACTER*40 PMDNAME, PMENAME, MAPEXENAME
	CHARACTER*1 ANSWER
	LOGICAL KBINPUT, LISTFLG, MAPFLG, ADDRFLG, STEPFLG, GETHFLG
	LOGICAL LINEFLG, LINEFLGVAL
C
	DATA KINDSTK/0, MAXKINDS*0/
C
C
C	*************** PICK UP THE INPUT AND OUTPUT FILE NAMES **************
C
C
C	***ASK THE USER WHETHER HE WANTS TO SPECIFY INPUT AND OUTPUT FILE NAMES
   10	PRINT 20
   20	FORMAT(' Do you wish to specify file names? (Yes or No): ',$)
	READ(KBD,30) ANSWER
   30	FORMAT(A1)
	IF(ANSWER .EQ. 'Y' .OR. ANSWER .EQ. 'y') GO TO 50
	IF(ANSWER .NE. 'N' .AND. ANSWER .NE. 'n') GO TO 10
C
C	***HE DOES NOT WANT TO SPECIFY FILE NAMES--GIVE HIM THE DEFAULT NAMES
	OPEN(UNIT=2, NAME='PMEFILE.PMD', TYPE='OLD', ERR=35)
	KBINPUT = .FALSE.
	GO TO 90
   35	PRINT 40
   40	FORMAT('0*** Program Definition File cannot be opened--',
     1		'all input is from keyboard ***'/)
	KBINPUT = .TRUE.
	GO TO 90
C
C	***HE WANTS TO SPECIFY FILE NAMES--ASK HIM WHAT THEY ARE
   50	PRINT 60
   60	FORMAT(' Enter name of definition (.PMD) file: ',$)
	READ(KBD,70) PMDNAME
   70	FORMAT(A40)
	KBINPUT = PMDNAME .EQ. 'SYS$INPUT' .OR. PMDNAME .EQ. 'SYS$INPUT:'
     1	     .OR. PMDNAME .EQ. 'sys$input' .OR. PMDNAME .EQ. 'sys$input:'
	IF(.NOT. KBINPUT) THEN
	    IF(PMDNAME .EQ. ' ') PMDNAME = 'PMEFILE.PMD'
	    ERRFLG = .TRUE.
	    OPEN(UNIT=2, NAME=PMDNAME, TYPE='OLD', ERR=75)
	    ERRFLG = .FALSE.
   75	    IF(ERRFLG) THEN
		PRINT 40
		KBINPUT = .TRUE.
	    ENDIF
	ENDIF
	PRINT 80
   80	FORMAT(' Enter name of output bucket (.PME) file: ',$)
	READ(KBD,70) PMENAME
	IF(PMENAME .EQ. ' ') PMENAME = 'PMEFILE.PME'
	CALL PME_ONAME(PMENAME)
C
C	***NOW INITIALIZE A FEW THINGS
   90	MODE = 1
	IMNUM = 0
	NKINDS = 0
	NUNITS = 0
	NGRPS = 0
	NBKTS = 0
	FLAGBITS = HDRFLG_CLR
	LISTFLG = .FALSE.
	PRINTFLG = .FALSE.
	LINESWITCH = 2
	ROUTSWITCH = 2
	KINDTBL(0) = ' '
	UNITTBL(0) = ' '
	UNITKIND(0) = 0
C
C
C	*************** READ IN AND PROCESS THE DEFINITION FILE ***************
C
C
C	***READ IN THE NEXT INPUT IMAGE FROM THE DEFINITION FILE OR THE KEYBOARD
  100	IF(KBINPUT) GO TO (120,140,160,180), MODE
	KBINPUT = .TRUE.
	READ(2,110,END=100) IMAGE
  110	FORMAT(A72)
	KBINPUT = .FALSE.
	GO TO 220
  120	PRINT 130
  130	FORMAT(' Enter DEFINE statement: ',$)
	GO TO 200
  140	PRINT 150
  150	FORMAT(' Enter program unit spec: ',$)
	GO TO 200
  160	PRINT 170
  170	FORMAT(' Enter address spec: ',$)
	GO TO 200
  180	PRINT 190
  190	FORMAT(' Enter sampling spec: ',$)
  200	READ(KBD,110,END=900) IMAGE
C
C	***WE GOT THE INPUT IMAGE--LIST IT IF LISTING IS DESIRED, TRANSLATE TABS
C	***TO SPACES, AND INITIALIZE THINGS FOR SCANNING IT.
  220	IMNUM = IMNUM + 1
	IF(LISTFLG) PRINT 230, IMNUM, IMAGE
  230	FORMAT(1X,I4,': ',A72)
	DO 240 I=1,72
	IF(IMAGE(I:I) .EQ. CHAR(9)) IMAGE(I:I) = ' '
  240	CONTINUE
	IMAGE(73:74) = '!!'
	IMPTR = 1
	ERRFLG = .FALSE.
C
C	***DETERMINE WHAT KIND OF STATEMENT THIS IS.  IF IT IS AN END STATEMENT,
C	***HANDLE IT RIGHT AWAY.
	CALL GETEND
	IF(ENDFLG) GO TO 100
	CALL GETNAME
	IF(ERRFLG) GO TO 100
	IF(NAME .EQ. 'END') THEN
	    CALL GETEND
	    IF(ENDFLG) GO TO 900
	    PRINT 250, IMNUM, IMAGE
  250	    FORMAT('0',I4,': ',A72/1X,<IMPTR+5>('-'),'!'/
     1		' *** Error:  Invalid character in statement ***')
	    GO TO 100
	ENDIF
	IF(NAME .NE. 'DEFINE') GO TO (350,360,360,360), MODE
C
C
C	****************** SCAN AND PROCESS DEFINE STATEMENTS *****************
C
C
C	***DETERMINE WHICH KIND OF DEFINE STATEMENT THIS IS.
	CALL GETNAME
	IF(ERRFLG) GO TO 100
C
C	***SCAN AND PROCESS THE "DEFINE UNITS: X, Y, Z" STATEMENT.
	IF(NAME(1:4) .EQ. 'UNIT') THEN
	    MODE = 2
	    CALL GETEND
	    IF(ENDFLG) GO TO 100
	    IF(IMAGE(IMPTR:IMPTR) .EQ. ':') IMPTR = IMPTR + 1
C
C	    ***GET THE NEXT PROGRAM UNIT KIND NAME AND CHECK IT FOR VALIDITY.
  260	    CALL GETNAME
	    IF(ERRFLG) GO TO 100
	    IF(NAME .EQ. 'DEFINE' .OR. NAME .EQ. 'END') THEN
		PRINT 270, IMNUM, IMAGE
  270		FORMAT('0',I4,': ',A72/1X,<NAMPTR+5>('-'),'!'/
     1		    ' *** Error:  Program unit kind doubly defined ***')
		GO TO 100
	    ENDIF
	    DO 280 I=0,NKINDS
	    IF(NAME .EQ. KINDTBL(I)) THEN
		PRINT 270, IMNUM, IMAGE
		GO TO 100
	    ENDIF
  280	    CONTINUE
C
C	    ***THE KIND NAME IS GOOD--ENTER IT IN THE KIND TABLE.
	    IF(NKINDS .EQ. MAXKINDS) THEN
		PRINT 290, IMNUM, IMAGE
  290		FORMAT('0',I4,': ',A72/1X,<NAMPTR+5>('-'),'!'/
     1		' *** Error:  Too many program unit kinds specified ***')
		GO TO 100
	    ENDIF
	    NKINDS = NKINDS + 1
	    KINDTBL(NKINDS) = NAME
	    CALL GETEND
	    IF(ENDFLG) GO TO 100
	    IF(IMAGE(IMPTR:IMPTR) .EQ. ',') IMPTR = IMPTR + 1
	    GO TO 260
	ENDIF
C
C	***SCAN AND PROCESS THE "DEFINE ADDRESSES" COMMAND WHICH CAN HAVE THE
C	***FOLLOWING FORMS:
C	***		DEFINE ADDRESSES
C	***		DEFINE ADDRESSES: MAP "FILESPEC" PSECT XXX
C	***		DEFINE ADDRESSES: EXE "FILESPEC" PSECT XXX
C	*** FIRST SET DEFINE-ADDRESSES MODE AND CHECK FOR THE COLON.
	IF(NAME(1:4) .EQ. 'ADDR') THEN
	    MODE = 3
	    CALL GETEND
	    IF(ENDFLG) GO TO 100
	    IF(IMAGE(IMPTR:IMPTR) .EQ. ':') IMPTR = IMPTR + 1
C
C	    ***PICK UP THE "MAP" OR "EXE" KEYWORD.
	    CALL GETNAME
	    IF(ERRFLG) GO TO 100
	    IF(NAME .EQ. 'MAP') THEN
		MAPFLG = .TRUE.
	    ELSE IF(NAME .EQ. 'EXE') THEN
		MAPFLG = .FALSE.
	    ELSE
		PRINT 300, IMNUM, IMAGE
  300		FORMAT('0',I4,': ',A72/1X,<NAMPTR+5>('-'),'!'/
     1		     ' *** Error:  Missing or invalid keyword ***')
		GO TO 100
	    ENDIF
C
C	    ***PICK UP THE .MAP OR .EXE FILE NAME--THIS NAME MUST BE ENCLOSED
C	    ***BY DOUBLE QUOTES.
	    CALL GETEND
	    IF(ENDFLG .OR. IMAGE(IMPTR:IMPTR) .NE. '"') THEN
		PRINT 310, IMNUM, IMAGE
  310		FORMAT('0',I4,': ',A72/1X,<IMPTR+5>('-'),'!'/
     1		    ' *** Error:  Missing or invalid file spec ***')
		GO TO 100
	    ENDIF
	    IMPTR = IMPTR + 1
	    N = MIN0(IMPTR + 40, 72)
	    DO 320 I=IMPTR,N
	    IF(IMAGE(I:I) .EQ. '"') GO TO 330
  320	    CONTINUE
	    IMPTR = N + 1
	    PRINT 310, IMNUM, IMAGE
	    GO TO 100
  330	    IF(I .EQ. IMPTR) THEN
		PRINT 310, IMNUM, IMAGE
		GO TO 100
	    ENDIF
	    MAPEXENAME = IMAGE(IMPTR:I-1)
	    IMPTR = I + 1
C
C	    ***IF PRESENT, PICK UP THE "PSECT" KEYWORD AND THE ACTUAL PSECT NAME
	    PSECTNAME = '$CODE'
	    CALL GETEND
	    IF(.NOT. ENDFLG) THEN
		CALL GETNAME
		IF(ERRFLG) GO TO 100
		IF(NAME .NE. 'PSECT') THEN
		    PRINT 300, IMNUM, IMAGE
		    GO TO 100
		ENDIF
		CALL GETNAME
		IF(ERRFLG) GO TO 100
		PSECTNAME = NAME
		CALL GETEND
		IF(.NOT. ENDFLG) THEN
		    PRINT 250, IMNUM, IMAGE
		    GO TO 100
		ENDIF
	    ENDIF
C
C	    ***CALL GETMAP OR GETEXE TO DO THE ACTUAL PROCESSING
	    IF(MAPFLG) THEN
		CALL GETMAP(MAPEXENAME,PSECTNAME)
	    ELSE
		CALL GETEXE(MAPEXENAME,PSECTNAME)
	    ENDIF
	    GO TO 100
	ENDIF
C
C	***HANDLE THE "DEFINE SAMPLING" COMMAND
	IF(NAME(1:4) .EQ. 'SAMP') THEN
	    MODE = 4
	    CALL GETEND
	    IF(.NOT. ENDFLG) PRINT 250, IMNUM, IMAGE
	    GO TO 100
	ENDIF
C
C	***HANDLE THE "DEFINE OPTIONS: LIST, ABSADDR" COMMAND.  THIS SETS EITHER
C	***THE HEADER FLAGS BITS OR LOCAL SWITCHES IN THIS PROGRAM.
	IF(NAME(1:3) .EQ. 'OPT') THEN
	    IF(IMAGE(IMPTR:IMPTR) .EQ. ':') IMPTR = IMPTR + 1
  340	    CALL GETNAME
	    IF(ERRFLG) GO TO 100
	    IF(NAME(1:10) .EQ. 'CLEARCOUNT') THEN
		FLAGBITS = IOR(FLAGBITS, HDRFLG_CLR)
	    ELSE IF(NAME(1:10) .EQ. 'ACCUMCOUNT') THEN
		FLAGBITS = IAND(FLAGBITS, NOT(HDRFLG_CLR))
	    ELSE IF(NAME .EQ. 'ABSADDR') THEN
		FLAGBITS = IOR(FLAGBITS, HDRFLG_ABS)
	    ELSE IF(NAME .EQ. 'RELADDR') THEN
		FLAGBITS = IAND(FLAGBITS, NOT(HDRFLG_ABS))
	    ELSE IF(NAME .EQ. 'LIST') THEN
		IF(.NOT. LISTFLG) PRINT 230, IMNUM, IMAGE
		LISTFLG = .TRUE.
	    ELSE IF(NAME .EQ. 'NOLIST') THEN
		LISTFLG = .FALSE.
	    ELSE IF(NAME .EQ. 'PRINT') THEN
		PRINTFLG = .TRUE.
	    ELSE IF(NAME .EQ. 'NOPRINT') THEN
		PRINTFLG = .FALSE.
	    ELSE IF(NAME(1:6) .EQ. 'NOLINE') THEN
		LINESWITCH = 1
	    ELSE IF(NAME(1:8) .EQ. 'SOMELINE') THEN
		LINESWITCH = 2
	    ELSE IF(NAME(1:4) .EQ. 'LINE') THEN
		LINESWITCH = 3
	    ELSE IF(NAME(1:9) .EQ. 'NOROUTINE') THEN
		ROUTSWITCH = 1
	    ELSE IF(NAME(1:7) .EQ. 'ROUTINE') THEN
		ROUTSWITCH = 2
	    ELSE
		PRINT 300, IMNUM, IMAGE
		GO TO 100
	    ENDIF
	    CALL GETEND
	    IF(ENDFLG) GO TO 100
	    IF(IMAGE(IMPTR:IMPTR) .EQ. ',') IMPTR = IMPTR + 1
	    GO TO 340
	ENDIF
C
C	***HANDLE THE "DEFINE CLEAR" COMMAND--CLEAR THE GROUP AND BUCKET TABLES
	IF(NAME .EQ. 'CLEAR') THEN
	    CALL GETEND
	    IF(.NOT. ENDFLG) THEN
		PRINT 250, IMNUM, IMAGE
		GO TO 100
	    ENDIF
	    NGRPS = 0
	    NBKTS = 0
	    GO TO 100
	ENDIF
C
C	*** HANDLE THE SECRET "DUMP$" AND "DUMP$FILE" COMMANDS
	IF(NAME .EQ. 'DUMP$') THEN
	    CALL DUMPER(.FALSE.)
	    GO TO 100
	ELSE IF(NAME .EQ. 'DUMP$FILE') THEN
	    CALL DUMPER(.TRUE.)
	    GO TO 100
	ENDIF
C
C	***HANDLE INVALID DEFINE COMMANDS.
  350	PRINT 300, IMNUM, IMAGE
	GO TO 100
C
C
C	***************** SCAN PROGRAM UNIT SPECIFICATIONS ********************
C
C
C	***SCAN COMMANDS OF THE FORM "KIND PROGUNIT, START - END, STEP".  START
C	***BY DETERMINING THE PROGRAM UNIT KIND AND THEN PICKING UP THE PROGRAM
C	***UNIT NAME.
  360	LOWUNIT = 0
	HIGHUNIT = NUNITS
  370	DO 380 IKIND=0,NKINDS
	IF(NAME .EQ. KINDTBL(IKIND)) GO TO 400
  380	CONTINUE
	PRINT 390, IMNUM, IMAGE
  390	FORMAT('0',I4,': ',A72/1X,<NAMPTR+5>('-'),'!'/
     1	    ' *** Error:  Invalid program unit kind ***')
	GO TO 100
  400	CALL GETNAME
	IF(ERRFLG) GO TO 100
	UNITNAME = NAME
	UNITPTR = NAMPTR
C
C	***IF WE ARE IN DEFINE UNITS MODE, GO DIRECTLY TO PICKING UP THE
C	***ADDRESS RANGE, ETC.  OTHERWISE SCAN AND LOOK UP A FULLY QUALI-
C	***FIED PROGRAM UNIT NAME (E.G., "MODULE X\ROUTINE Y\LINE 10") IN
C	***THE UNIT TABLE.  WHEN WE ARE DONE, IKIND AND IUNIT WILL BE SET.
	IF(MODE .NE. 2) THEN
	    TALLY = 0
	    GETHFLG = .FALSE.
	    DO 410 I=LOWUNIT,HIGHUNIT
	    IF(UNITKIND(I) .EQ. IKIND .AND. UNITTBL(I) .EQ. UNITNAME) THEN
		TALLY = TALLY + 1
		IUNIT = I
		GETHFLG = .TRUE.
	    ELSE IF(UNITKIND(I) .LE. IKIND) THEN
		GETHFLG = .FALSE.
	    ENDIF
	    IF(GETHFLG) HUNIT = I
  410	    CONTINUE
	    IF(TALLY .EQ. 0) THEN
		PRINT 420, IMNUM, IMAGE
  420		FORMAT('0',I4,': ',A72/1X,<UNITPTR+5>('-'),'!'/
     1		    ' *** Error:  Undefined program unit ***')
		GO TO 100
	    ELSE IF(TALLY .NE. 1) THEN
		PRINT 430, IMNUM, IMAGE
  430		FORMAT('0',I4,': ',A72/1X,<UNITPTR+5>('-'),'!'/
     1		    ' *** Error:  Ambiguous program unit spec ***')
		GO TO 100
	    ENDIF
	    LOWUNIT = IUNIT
	    HIGHUNIT = HUNIT
	    IF(IMAGE(IMPTR:IMPTR) .EQ. '\') THEN
		IMPTR = IMPTR + 1
		CALL GETNAME
		IF(ERRFLG) GO TO 100
		GO TO 370
	    ENDIF
	ENDIF
C
C	***PREPARE TO PICK UP THE START ADDRESS, END ADDRESS, STEP SIZE, AND
C	***KEYWORD PARAMETERS.  IF THERE IS A "BY KIND" CLAUSE, GO TO 650.
	ADDRFLG = .FALSE.
	STEPFLG = .FALSE.
	LINEFLG = .FALSE.
	CALL GETEND
	IF(ENDFLG) GO TO 480
	IF(IMAGE(IMPTR:IMPTR+2) .EQ. 'BY ' .OR.
     1		IMAGE(IMPTR:IMPTR+2) .EQ. 'by ') GO TO 650
	IF(IMAGE(IMPTR:IMPTR) .NE. ',') THEN
	    PRINT 250, IMNUM, IMAGE
	    GO TO 100
	ENDIF
	IMPTR = IMPTR + 1
	CALL GETEND
	IF(ENDFLG) GO TO 480
	IF(IMAGE(IMPTR:IMPTR) .EQ. ',') GO TO 450
C
C	***THE ADDRESS RANGE SPECIFICATION IS PRESENT--PICK IT UP.
	CALL GETHEX
	IF(ERRFLG) GO TO 100
	LOWHEX = HEXNUM
	LOWHEXPTR = NAMPTR
	IF(IMAGE(IMPTR:IMPTR) .EQ. '-') IMPTR = IMPTR + 1
	CALL GETHEX
	IF(ERRFLG) GO TO 100
	HIHEX = HEXNUM
	IF(LOWHEX .GT. HIHEX .OR. (LOWHEX.LT.0 .AND. HIHEX.GE.0)) THEN
	    PRINT 440, IMNUM, IMAGE
  440	    FORMAT('0',I4,': ',A72/1X,<LOWHEXPTR+5>('-'),'!'/
     1		' *** Error:  Invalid address range specified ***')
	    GO TO 100
	ENDIF
	ADDRFLG = .TRUE.
C
C	***SCAN PAST THE COMMA AFTER THE ADDRESS RANGE SPECIFICATION.
	CALL GETEND
	IF(ENDFLG) GO TO 480
	IF(IMAGE(IMPTR:IMPTR) .NE. ',') THEN
	    PRINT 250, IMNUM, IMAGE
	    GO TO 100
	ENDIF
C
C	***SEE IF THE STEP SIZE IS PRESENT.
  450	IMPTR = IMPTR + 1
	CALL GETEND
	IF(ENDFLG) GO TO 480
	IF(IMAGE(IMPTR:IMPTR) .EQ. ',') GO TO 470
C
C	***THE STEP SIZE IS PRESENT--PICK IT UP.
	CALL GETHEX
	IF(ERRFLG) GO TO 100
	STEPHEX = HEXNUM
	IF(STEPHEX .LE. 0) THEN
	    PRINT 460, IMNUM, IMAGE
  460	    FORMAT('0',I4,': ',A72/1X,<NAMPTR+5>('-'),'!'/
     1		' *** Error:  Zero or negative step size ***')
	    GO TO 100
	ENDIF
	STEPFLG = .TRUE.
C
C	***SCAN PAST THE COMMA (IF ANY) AFTER THE STEP SIZE.
	CALL GETEND
	IF(ENDFLG) GO TO 480
	IF(IMAGE(IMPTR:IMPTR) .NE. ',') THEN
	    PRINT 250, IMNUM, IMAGE
	    GO TO 100
	ENDIF
C
C	***THEN PICK UP ANY KEYWORD PARAMETERS THAT ARE PRESENT.
  470	IMPTR = IMPTR + 1
	CALL GETNAME
	IF(ERRFLG) GO TO 100
	IF(MODE .EQ. 4) NAME = ' '
	IF(NAME(1:4) .EQ. 'LINE') THEN
	    LINEFLGVAL = .TRUE.
	    LINEFLG = .TRUE.
	ELSE IF(NAME(1:6) .EQ. 'NOLINE') THEN
	    LINEFLGVAL = .FALSE.
	    LINEFLG = .TRUE.
	ELSE
	    PRINT 300, IMNUM, IMAGE
	    GO TO 100
	ENDIF
	CALL GETEND
	IF(ENDFLG) GO TO 480
CCCCC	IF(IMAGE(IMPTR:IMPTR) .EQ. ',') GO TO 470
	PRINT 250, IMNUM, IMAGE
	GO TO 100
C
C	***WE HAVE PARSED AND PICKED UP ALL THE SPECIFICATION FIELDS.  NOW
C	***DISPATCH ACCORDING TO THE CURRENT SPECIFICATION MODE.
  480	GO TO (100,500,550,580), MODE
C
C
C	***************** PROCESS PROGRAM UNIT SPECIFICATIONS *****************
C
C
C	***HANDLE THE DEFINITION OF NEW PROGRAM UNITS (DEFINE UNITS MODE).
  500	DO 520 I = KINDSTK(IKIND - 1), NUNITS
	IF(IKIND .EQ. UNITKIND(I) .AND. UNITNAME .EQ. UNITTBL(I)) THEN
	    PRINT 510, IMNUM, IMAGE
  510	    FORMAT('0',I4,': ',A72/1X,<UNITPTR+5>('-'),'!'/
     1	    ' *** Error:  Double definition of program unit name ***')
	    GO TO 100
	ENDIF
  520	CONTINUE
	IF(NUNITS .EQ. MAXUNITS) THEN
	    PRINT 530, IMNUM, IMAGE
  530	    FORMAT('0',I4,': ',A72/1X,<UNITPTR+5>('-'),'!'/
     1		' *** Error:  Too many program units defined ***')
	    GO TO 100
	ENDIF
	NUNITS = NUNITS + 1
	UNITKIND(NUNITS) = IKIND
	UNITTBL(NUNITS) = UNITNAME
C
	IF(ADDRFLG) THEN
	    LOWADDR(NUNITS) = LOWHEX
	    HIADDR(NUNITS) = HIHEX
	ELSE
	    LOWADDR(NUNITS) = 1
	    HIADDR(NUNITS) = 0
	ENDIF
C
	IF(STEPFLG) THEN
	    STEPSIZ(NUNITS) = STEPHEX
	ELSE
	    STEPSIZ(NUNITS) = '7FFFFFFF'X
	ENDIF
C
	IF(LINEFLG) THEN
	    UNITLINEFLG(NUNITS) = LINEFLGVAL
	ELSE
	    UNITLINEFLG(NUNITS) = .FALSE.
	ENDIF
C
	DO 540 I=IKIND,MAXKINDS
  540	KINDSTK(I) = NUNITS
	GO TO 100
C
C
C	***HANDLE THE DEFINITION OF ADDRESSES (DEFINE ADDRESSES MODE).
  550	IF(ADDRFLG) THEN
	    LOWADDR(IUNIT) = LOWHEX
	    HIADDR(IUNIT) = HIHEX
	ENDIF
	IF(STEPFLG) STEPSIZ(IUNIT) = STEPHEX
	IF(LINEFLG) UNITLINEFLG(IUNIT) = LINEFLGVAL
	GO TO 100
C
C
C	***HANDLE THE CREATION OF EQUAL-SIZED SAMPLING BUCKETS FOR A SINGLE
C	***PROGRAM UNIT (DEFINE SAMPLING MODE).
  580	IF(STEPFLG) STEPSIZ(IUNIT) = STEPHEX
	CALL GETRANGE(IUNIT, LOW, HIGH, STEP)
	IF(ERRFLG) THEN
	    IF(LOW .EQ. 1) THEN
		PRINT 600, IMNUM, IMAGE
  600		FORMAT('0',I4,': ',A72/1X,<UNITPTR+5>('-'),'!'/
     1		' *** Error:  Program unit has undefined address ',
     2		'range ***')
	    ELSE
		PRINT 610, IMNUM, IMAGE
  610		FORMAT('0',I4,': ',A72/1X,<UNITPTR+5>('-'),'!'/
     1		' *** Error:  Program unit covers both positive and ',
     2		'negative addresses ***')
	    ENDIF
	    GO TO 100
	ENDIF
	BASEADDR = LOW
	IF(ADDRFLG) THEN
	    IF(LOWHEX .LT. 0 .OR. LOWHEX .GT. HIGH - LOW
     1		    .OR. HIHEX .GT. HIGH - LOW) THEN
		PRINT 440, IMNUM, IMAGE
		GO TO 100
	    ENDIF
	    HIGH = LOW + HIHEX
	    LOW = LOW + LOWHEX
	ENDIF
	NUMBKTS = (HIGH - LOW)/STEP + 1
	CALL ENTERGRP(IUNIT, LOW, HIGH, STEP, NUMBKTS, 0)
	IF(ERRFLG) GO TO 100
	DO 620 I=1,NUMBKTS
	BLO = LOW + (I - 1)*STEP
	IF(HIGH - BLO .GT. STEP - 1) THEN
	    BHI = BLO + (STEP - 1)
	ELSE
	    BHI = HIGH
	ENDIF
	CALL ENTERBKT(IUNIT, BLO, BHI, BASEADDR)
	IF(ERRFLG) THEN
	    NGRPS = NGRPS - 1
	    GO TO 100
	ENDIF
  620	CONTINUE
	GO TO 100
C
C	***SCAN THE "KIND PROGUNIT BY KIND" SPECIFICATION TO PICK UP THE SECOND
C	***KIND NAME (AFTER THE "BY").  (DEFINE SAMPLING MODE.)
  650	IMPTR = IMPTR + 3
	CALL GETNAME
	IF(ERRFLG) GO TO 100
	DO 680 BYKIND=0,NKINDS
	IF(NAME .EQ. KINDTBL(BYKIND)) GO TO 690
  680	CONTINUE
	PRINT 390, IMNUM, IMAGE
	GO TO 100
  690	CALL GETEND
	IF(.NOT. ENDFLG) THEN
	    PRINT 250, IMNUM, IMAGE
	    GO TO 100
	ENDIF
	IF(BYKIND .LE. IKIND) THEN
	    PRINT 700, IMNUM, IMAGE
  700	    FORMAT('0',I4,': ',A72/1X,<NAMPTR+5>('-'),'!'/
     1		' *** Error: This is not a subunit of the specified',
     2		' program unit ***')
	    GO TO 100
	ENDIF
C
C	***PROCESS THE "BY KIND" CLAUSE TO GENERATE THE PROPER SAMPLING BUCKETS.
C	***START BY CREATING A NEW BUCKET GROUP (A GROUP TABLE ENTRY).
	CALL GETRANGE(IUNIT, LOW, HIGH, STEP)
	IF(ERRFLG) THEN
	    IF(LOW .EQ. 1) THEN
		PRINT 600, IMNUM, IMAGE
	    ELSE
		PRINT 610, IMNUM, IMAGE
	    ENDIF
	    GO TO 100
	ENDIF
	NUMBKTS = 500
	CALL ENTERGRP(IUNIT, LOW, HIGH, STEP, NUMBKTS, BYKIND)
	IF(ERRFLG) GO TO 100
	BYCOUNT = 0
C
C	***LOOP THROUGH THE SUBUNITS OF THE SPECIFIED PROGRAM UNIT TO GENERATE
C	***SAMPLING BUCKETS.
  720	IUNIT = IUNIT + 1
	IF(IUNIT .GT. NUNITS) GO TO 760
	IF(UNITKIND(IUNIT) .LE. IKIND) GO TO 760
	IF(UNITKIND(IUNIT) .NE. BYKIND) GO TO 720
	CALL GETRANGE(IUNIT, LOW, HIGH, STEP)
	IF(ERRFLG) THEN
	    PRINT 730, IMNUM, IMAGE, UNITTBL(IUNIT)
  730	    FORMAT('0',I4,': ',A72/' *** Program unit not included',
     1		' due to undefined address range: ',A16,' ***')
	    GO TO 720
	ENDIF
	BASEADDR = LOW
	NUMBKTS = (HIGH - LOW)/STEP + 1
C
C	***LOOP TO GENERATE THE PROPER NUMBER OF EQUAL-SIZED BUCKETS (POSSIBLY
C	***ONLY ONE) WITHIN THE SUBUNIT.
	DO 750 I=1,NUMBKTS
	BLO = LOW + (I - 1)*STEP
	IF(HIGH - BLO .GT. STEP - 1) THEN
	    BHI = BLO + (STEP - 1)
	ELSE
	    BHI = HIGH
	ENDIF
	CALL ENTERBKT(IUNIT, BLO, BHI, BASEADDR)
	IF(ERRFLG) THEN
	    NGRPS = NGRPS - 1
	    GO TO 100
	ENDIF
	BYCOUNT = BYCOUNT + 1
  750	CONTINUE
	GO TO 720
C
C	***ALL DONE WITH THE "BY KIND" BUCKET GENERATION--MAKE SURE AT LEAST
C	***ONE BUCKET WAS ACTUALLY GENERATED.
  760	IF(BYCOUNT .EQ. 0) THEN
	    PRINT 770, IMNUM, IMAGE
  770	    FORMAT('0',I4,': ',A72/
     1		' *** Error:  No buckets were found in this group ***')
	    NGRPS = NGRPS - 1
	ENDIF
	GO TO 100
C
C
C	********************** GENERATE BUCKET FILE ************************
C
C
C	***THE INPUT STREAM ENDED--NOW CREATE A NEW BUCKET FILE AND STOP.
  900	CALL MAKEFILE
	IF(ERRFLG) GO TO 100
	PRINT 910
  910	FORMAT('0*** Bucket File created ***'/)
	END


	SUBROUTINE DUMPER(FILEFLG)
C
C
C	SUBROUTINE TO DUMP OUT ALL THE INTERNAL DATA TABLES IN THE PMEBUILD
C	PROGRAM.  THE SUBROUTINE IS CALLED AS FOLLOWS:
C
C			CALL DUMPER(FILEFLG)
C
C	IF FILEFLG = .TRUE., THE DUMP IS WRITTEN OUT TO A NEW FILE CALLED
C	"DUMPFILE.TMP"; IF FILEFLG = .FALSE., THE DUMP IS WRITTEN OUT TO THE
C	USER'S TERMINAL (UNIT 6).
C
C
C	***DATA DEFINITIONS
	INCLUDE 'PMECOMMON.FOR/NOLIST'
	LOGICAL FILEFLG
C
C	***FIRST SET UP THE LOGICAL UNIT NUMBER TO WRITE THE DUMP TO--ALSO,
C	***IF THE CALLER WANTS A FILE, OPEN IT.
	IF(FILEFLG) THEN
	    DUNIT = 10
	    OPEN(UNIT=DUNIT, NAME='DUMPFILE.TMP', TYPE='NEW')
	ELSE
	    DUNIT = 6
	ENDIF
	WRITE(DUNIT,10)
   10	FORMAT('0*** Start of dump ***')
C
C	***DUMP OUT THE KIND AND PROGRAM UNIT TABLES
	WRITE(DUNIT,20) NKINDS, (I, KINDTBL(I), I=1,NKINDS)
   20	FORMAT('0*** The Kind Table -- NKINDS =',I4,' ***'//
     1	    ' ---NUM---NAME-----------'/
     2	    9000(1X,I6,': ',A16/))
	WRITE(DUNIT,30) NUNITS, (I, LOWADDR(I), HIADDR(I), STEPSIZ(I),
     1	    UNITLINEFLG(I), UNITKIND(I), UNITTBL(I), I=1,NUNITS)
   30	FORMAT('0*** The Program Unit Table -- NUNITS =',I5,' ***'//
     1	    ' ---NUM-----LOWADDR----HIADDR--STEPSIZ---LFLG--KIND---',
     2	    'NAME-----------'/9000(1X,I6,':',3Z10,5X,L1,I6,3X,A16/))
C
C	***DUMP OUT THE BUCKET GROUP TABLE AND THE BUCKET TABLE
	WRITE(DUNIT,40) NGRPS, (I, GRPLOW(I), GRPHIGH(I), GRPSTEP(I),
     1	    GRPNBKTS(I), GRPNAMPTR(I), GRPLOPTR(I), GRPHIPTR(I),
     2	    I=1,NGRPS)
   40	FORMAT('0*** The Bucket Group Table -- NGRPS =',I3,' ***'//
     1	    ' ---NUM--------LOW------HIGH------STEP----NBKTS--NAMPTR',
     2	    '---LOPTR---HIPTR-'/9000(1X,I6,':',3Z10,4I8/))
	WRITE(DUNIT,50) NBKTS, (I, BKTNAMPTR(I), BKTLOW(I), BKTHIGH(I),
     1	    BKTBASE(I), I=1,NBKTS)
   50	FORMAT('0*** The Bucket Table -- NBKTS =',I5,' ***'//
     1	    ' ---NUM--NAMPTR------LOW------HIGH------BASE-'/
     2	    9000(I6,':',I7,3Z10/))
C
C	***ALL DONE--CLOSE THE FILE (IF NECESSARY) AND RETURN
	WRITE(DUNIT,60)
   60	FORMAT('0*** End of dump ***')
	IF(FILEFLG) CLOSE(UNIT=DUNIT)
	RETURN
	END

	SUBROUTINE ENTERBKT(IUNIT, LOW, HIGH, BASEADDR)
C
C
C	SUBROUTINE TO CREATE ONE BUCKET ENTRY.  THIS SUBROUTINE, WHICH IS CALLED
C	DURING THE PROCESSING OF SAMPLING SPECIFICATIONS, IS CALLED LIKE THIS:
C
C			CALL ENTERBKT(IUNIT, LOW, HIGH, BASEADDR)
C
C	WHERE IUNIT IS A PROGRAM UNIT TABLE POINTER TO THE PROGRAM UNIT IN WHICH
C	THIS BUCKET IS CONTAINED, LOW IS THE LOW ADDRESS OF THE BUCKET'S ADDRESS
C	RANGE, HIGH IS THE CORRESPONDING HIGH ADDRESS, AND BASEADDR IS THE BASE
C	ADDRESS OF THE PROGRAM UNIT CONTAINING THIS BUCKET (BASEADDR IS NEEDED
C	TO COMPUTE UNIT-RELATIVE ADDRESSES FOR THE EVENTUAL HISTOGRAM). THE
C	SUBROUTINE CREATES A NEW BUCKET TABLE ENTRY BY FILLING IN THE BKTNAMPTR,
C	BKTLOW, BKTHIGH, AND BKTBASE ARRAYS WITH THE NEW BUCKET INFORMATION.
C	IT ALSO SETS THE GRPHIPTR POINTER IN THE CURRENT GROUP ENTRY TO POINT
C	TO THE BUCKET ENTRY JUST CREATED.
C
C	IF THE NEW BUCKET OVERLAPS A PREVIOUS BUCKET'S ADDRESS RANGE OR IF THE
C	BUCKET TABLE OVERFLOWS, ENTERBKT RETURNS WITH ERRFLG = .TRUE..
C
C
C	***DATA DEFINITIONS
	INCLUDE 'PMECOMMON.FOR/NOLIST'
C
C	***FIRST MAKE SURE THIS BUCKET'S ADDRESS RANGE DOES NOT OVERLAP THAT
C	***OF ANY OTHER BUCKET IN THIS BUCKET GROUP.
	ERRFLG = .FALSE.
	I = GRPLOPTR(NGRPS)
   10	IF(I .GT. NBKTS) GO TO 30
	I = I + 1
	IF(BKTLOW(I-1) .GT. HIGH .OR. LOW .GT. BKTHIGH(I-1)) GO TO 10
	PRINT 20, IMNUM, IMAGE
   20	FORMAT('0',I4,': ',A72/' *** Error:  Overlapping',
     1	    ' address ranges for two buckets in sampling group ***')
	ERRFLG = .TRUE.
	RETURN
C
C	***THEN MAKE SURE WE HAVE ROOM IN THE BUCKET TABLE
   30	IF(NBKTS .EQ. MAXBKTS) THEN
	    PRINT 40, IMNUM, IMAGE
   40	    FORMAT('0',I4,': ',A72/
     1	    ' *** Error:  Too many sampling buckets specified ***')
	    ERRFLG = .TRUE.
	    RETURN
	ENDIF
C
C	***NOW CREATE THE NEW BUCKET ENTRY
	NBKTS = NBKTS + 1
	BKTNAMPTR(NBKTS) = IUNIT
	BKTLOW(NBKTS) = LOW
	BKTHIGH(NBKTS) = HIGH
	BKTBASE(NBKTS) = BASEADDR
	GRPHIPTR(NGRPS) = NBKTS
C
C	***PRINT OUT THE BUCKET INFORMATION ON THE USER'S TERMINAL IF THE
C	***PRINTFLG SWITCH REQUESTS IT.
	IF(.NOT. PRINTFLG) RETURN
	PRINT 80, NBKTS, LOW, HIGH, BASEADDR, UNITTBL(IUNIT)
   80	FORMAT(1X,I6,3Z10,4X,A16)
	RETURN
	END

	SUBROUTINE ENTERGRP(IUNIT, LOW, HIGH, STEP, NUMBKTS, BYKIND)
C
C
C	SUBROUTINE TO CREATE A BUCKET GROUP ENTRY.  THIS SUBROUTINE, WHICH IS
C	CALLED DURING THE PROCESSING OF SAMPLING SPECIFICATIONS, IS CALLED
C	LIKE THIS:
C
C		CALL ENTERGRP(IUNIT,LOW,HIGH,STEP,NUMBKTS,BYKIND)
C
C	WHERE IUNIT POINTS TO THE UNIT ENTRY FOR THE PROGRAM UNIT IN WHICH
C	THIS BUCKET GROUP IS CONTAINED, LOW IS THE LOW ADDRESS OF THE GROUP'S
C	ADDRESS RANGE, HIGH IS THE CORRESPONDING HIGH ADDRESS, STEP IS THE
C	STEP SIZE (INDEX TABLE BUCKET SIZE) TO BE USED IN ACCESSING BUCKETS
C	WITHIN THE GROUP, AND NUMBKTS IS THE CORRESPONDING INDEX TABLE SIZE.
C	BYKIND POINTS TO THE APPROPRIATE KIND TABLE ENTRY IF BUCKETS IN THIS
C	GROUP ARE GENERATED BY PROGRAM UNIT KIND (E.G., PHASE ONE BY MODULE).
C	OTHERWISE, BYKIND = ZERO ON ENTRY.
C
C	IF THE GROUP'S ADDRESS RANGE OVERLAPS THAT OF ANOTHER GROUP OR IF THE
C	GROUP TABLE OVERFLOWS, ENTERGRP RETURNS WITH ERRFLG = .TRUE..
C
C
C	***DATA DEFINITIONS
	INCLUDE 'PMECOMMON.FOR/NOLIST'
C
C	***FIRST MAKE SURE THIS GROUP'S ADDRESS RANGE DOES NOT OVERLAP THAT
C	***OF ANY OTHER BUCKET GROUP.
	ERRFLG = .FALSE.
	I = 1
   10	IF(I .GT. NGRPS) GO TO 30
	I = I + 1
	IF(GRPLOW(I-1) .GT. HIGH .OR. LOW .GT. GRPHIGH(I-1)) GO TO 10
	PRINT 20, IMNUM, IMAGE
   20	FORMAT('0',I4,': ',A72/' *** Error:  Overlapping address',
     1	    ' range with a previous sampling group ***')
	ERRFLG = .TRUE.
	RETURN
C
C	***THEN MAKE SURE WE STILL HAVE ROOM IN THE BUCKET GROUP TABLE
   30	IF(NGRPS .EQ. MAXGRPS) THEN
	    PRINT 40, IMNUM, IMAGE
   40	    FORMAT('0',I4,': ',A72/
     1	    ' *** Error:  Too many sampling groups specified ***')
	    ERRFLG = .TRUE.
	    RETURN
	ENDIF
C
C	***NOW CREATE THE NEW BUCKET GROUP ENTRY
	NGRPS = NGRPS + 1
	GRPNAMPTR(NGRPS) = IUNIT
	GRPLOW(NGRPS) = LOW
	GRPHIGH(NGRPS) = HIGH
	GRPSTEP(NGRPS) = STEP
	GRPNBKTS(NGRPS) = NUMBKTS
	GRPLOPTR(NGRPS) = NBKTS + 1
	GRPHIPTR(NGRPS) = 0
C
C	***CONSTRUCT THE "NAME STRING" FOR THIS GROUP.  THIS STRING WILL EITHER
C	***SAY "KINDNAME UNITNAME" OR "KINDNAME UNITNAME BY KINDNAME".
	GRPNAMSTR(NGRPS) = ' '
	IKIND = UNITKIND(IUNIT)
	DO 60 I=16,1,-1
	IF(KINDTBL(IKIND)(I:I) .NE. ' ') GO TO 70
   60	CONTINUE
	STOP '--> ERROR 1 IN ENTERGRP'
   70	GRPNAMSTR(NGRPS)(1:I) = KINDTBL(IKIND)(1:I)
	N = I + 1
	DO 80 I=16,1,-1
	IF(UNITTBL(IUNIT)(I:I) .NE. ' ') GO TO 90
   80	CONTINUE
	STOP '--> ERROR 2 IN ENTERGRP'
   90	GRPNAMSTR(NGRPS)(N+1:N+I) = UNITTBL(IUNIT)(1:I)
	IF(BYKIND .NE. 0) THEN
	    N = N + I
	    GRPNAMSTR(NGRPS)(N+2:N+3) = 'BY'
	    N = N + 4
	    DO 100 I=16,1,-1
	    IF(KINDTBL(BYKIND)(I:I) .NE. ' ') GO TO 110
  100	    CONTINUE
	    STOP '--> ERROR 3 IN ENTERGRP'
  110	    GRPNAMSTR(NGRPS)(N+1:N+I) = KINDTBL(BYKIND)(1:I)
	ENDIF
C
C	***PRINT OUT GROUP INFORMATION AND A BUCKET INFORMATION HEADER LINE ON
C	***THE USER'S TERMINAL IF THE PRINTFLG SWITCH REQUESTS IT.
	IF(.NOT. PRINTFLG) RETURN
	PRINT 150, NGRPS, GRPNAMSTR(NGRPS), LOW, STEP, HIGH, NUMBKTS
  150	FORMAT('0-----GROUP',I3,':  ',A60//
     1		' Low addr:  ',Z8,' (hex)    Step size:  ',Z8,' (hex)'/
     2		' High addr: ',Z8,' (hex)    Index Table:',I8,' (dec)'/
     3		'0              Buckets within group:'/
     4		'0--BKTNUM-----LOW------HIGH------BASE----PROG UNIT NAME-')
	RETURN
	END

	SUBROUTINE GETEND
C
C
C	SUBROUTINE TO SCAN FOR THE NEXT NON-BLANK CHARACTER AND DETERMINE IF
C	IT IS A COMMENT DELIMITER (I.E., THE END OF THE STATEMENT).  THE CALL
C	IS AS FOLLOWS:
C
C			CALL GETEND
C
C	THE ROUTINE USES THE FOLLOWING COMMON VARIABLES:
C
C	*** IMAGE	= THE USER'S INPUT IMAGE TO BE SCANNED.  THE VERY LAST
C			  COLUMN OF THIS IMAGE IS ASSUMED TO CONTAIN A COMMENT
C			  CHARACTER.
C	*** IMPTR	= SCAN POINTER INTO THE INPUT IMAGE.
C	*** ENDFLG	= THE RETURNED END-OF-LINE FLAG; IF .TRUE., A COMMENT
C			  CHARACTER WAS FOUND, IF .FALSE., IT WAS NOT.
C
C
C	***DATA DECLARATIONS
	INCLUDE 'PMECOMMON.FOR/NOLIST'
C
C	***SCAN PAST ANY LEADING BLANKS
   10	IF(IMAGE(IMPTR:IMPTR) .NE. ' ') GO TO 20
	IMPTR = IMPTR + 1
	GO TO 10
C
C	***NOW SEE IF THE NEXT CHARACTER IS A COMMENT CHARACTER.  IF SO, RETURN
C	***ENDFLG = .TRUE. AND IF NOT, RETURN ENDFLG = .FALSE.
   20	ENDFLG = .FALSE.
	IF(IMAGE(IMPTR:IMPTR) .EQ. '!') ENDFLG = .TRUE.
	IF(IMAGE(IMPTR:IMPTR) .EQ. ';') ENDFLG = .TRUE.
	RETURN
	END

	SUBROUTINE GETEXE(EXENAME,PSECTNAME)
C
C
C	SUBROUTINE TO PICK UP ADDRESS RANGES FOR PROGRAM UNITS BY READING THE
C	TRACEBACK INFORMATION IN THE EXECUTABLE IMAGE (THE .EXE FILE).  THIS
C	SUBROUTINE IS CALLED AS FOLLOWS:
C
C			CALL GETEXE(EXENAME,PSECTNAME)
C
C	WHERE EXENAME IS THE FILE NAME OF THE EXECUTABLE IMAGE TO BE EXAMINED
C	AND PSECTNAME IS THE NAME OF THE PSECT WHOSE ADDRESS RANGES ARE TO BE
C	USED.
C
C	SOME OF THE VARIABLES USED IN GETEXE ARE:
C
C	*** LANGUAGE	= THE DEBUGGER LANGUAGE CODE: 0 = MACRO, 1 = FORTRAN,
C			  2 = BLISS-32, 3 = COBOL, AND 4 = BASIC.
C	*** MODE	= CURRENT MODE: 1 = LOOK FOR A MODULE, 2 = LOOK FOR A
C			  ROUTINE WITHIN THE CURRENT MODULE, AND 3 = LOOK FOR
C			  LINE NUMBERS WITHIN THE CURRENT ROUTINE.
C
C
C	***DEFINE DATA AREAS
	INCLUDE 'PMECOMMON.FOR/NOLIST'
	COMMON/EXECOM/ ERRORFLG
	LOGICAL ERRORFLG, EOFFLG, ROUTERR, LINEERR, TEMPFLG
C
	PARAMETER MAXROUTS = 200, MAXLINES = 2000
	DIMENSION ROUTNAME(MAXROUTS), ROUTSTART(MAXROUTS)
	DIMENSION ROUTEND(MAXROUTS), ROUTLPTR(0:MAXROUTS)
	DIMENSION LINETBL(MAXLINES), PCTBL(MAXLINES)
	DIMENSION TEMPNAME(MAXUNITS), TEMPTBL(4,MAXUNITS)
	DIMENSION TEMPFLG(MAXUNITS)
	CHARACTER*40 EXENAME
	CHARACTER*16 PSECTNAME, MODNAME, ROUTNAME, PSECTSTR, TEMPNAME
	CHARACTER*16 GETEXESTRVAL, TEMPROUTNAME
	BYTE EQBYTE
	INTEGER*4 EQLONG
	EQUIVALENCE (EQBYTE,EQLONG)
	DATA ROUTLPTR(0)/0/
C
C
C	********************** INITIALIZE THINGS ***************************
C
C
C	***DETERMINE WHICH KIND TABLE ENTRY REFERS TO KIND MODULE, AND MAKE
C	***SURE THERE IS SUCH AN ENTRY.
	ERRFLG = .FALSE.
	DO 20 MODKIND=1,NKINDS
	IF(KINDTBL(MODKIND) .EQ. 'MODULE') GO TO 50
   20	CONTINUE
	PRINT 30, IMNUM, IMAGE
   30	FORMAT('0',I4,': ',A72/
     1	    ' *** Error:  Program unit kind MODULE does not exist ***',
     2	    ' ***         DEFINE ADDRESSES: EXE cannot be used    ***')
	ERRFLG = .TRUE.
	RETURN
C
C	***DETERMINE WHICH KIND TABLE ENTRIES, IF ANY, REFER TO ROUTINE AND
C	***LINE.  THE HIERARCHY MUST BE MODULE > ROUTINE > LINE.
   50	DO 60 ROUTKIND=MODKIND,NKINDS
	IF(KINDTBL(ROUTKIND) .EQ. 'ROUTINE') GO TO 70
   60	CONTINUE
	ROUTKIND = 0
   70	DO 80 LINEKIND=MODKIND,NKINDS
	IF(KINDTBL(LINEKIND) .EQ. 'LINE') GO TO 90
   80	CONTINUE
	LINEKIND = 0
   90	IF(LINEKIND .LE. ROUTKIND) LINEKIND = 0
C
C	***OPEN THE EXECUTABLE IMAGE FILE AND GET TO THE DEBUG SYMBOL TABLE
C	***SO WE CAN START PICKING UP THE TRACEBACK INFORMATION.  ALSO ESTAB-
C	***LISH LOOK-FOR-MODULE MODE AS THE CURRENT MODE.
	CALL GETEXEFILE(EXENAME)
	IF(ERRORFLG) RETURN
	MODE = 1
C
C
C	********************* PROCESS TRACEBACK RECORDS ************************
C
C
C	***GET THE NEXT DEBUG SYMBOL TABLE RECORD.  CHECK FOR END OF THE DEBUG
C	***SYMBOL TABLE AND SKIP OVER ANY UNWANTED RECORDS.  OTHERWISE, DIS-
C	***PATCH ON THE OPCODE AND THE CURRENT MODE.
  150	CALL EXEEOF(EOFFLG)
	IF(EOFFLG) GO TO 900
	CALL EXEBYTE(BYTCNT)
	IF(ERRORFLG) GO TO 920
	IF(BYTCNT .EQ. 0) GO TO 900
	CALL EXEBYTE(OPCODE)
	IF(ERRORFLG) GO TO 920
	IF(OPCODE .LT. 184 .OR. OPCODE .GT. 191) GO TO 180
	I = (OPCODE - 184)*3 + MODE
	GO TO (200,450,450,200,200,300,180,180,180,180,180,180,
C	       ----184---- ----185---- ----186---- ----187----
     1	       250,200,200,200,580,500,200,270,260,200,200,400),I
C	       ----188---- ----189---- ----190---- ----191----
C
C
C	***SKIP OVER THE CURRENT RECORD--WE ARE NOT INTERESTED IN IT.
  180	CALL EXESKIP(BYTCNT - 1)
	IF(ERRORFLG) GO TO 920
	GO TO 150
C
C	***THIS OPCODE-MODE COMBINATION SHOULD NEVER OCCUR--GIVE A NASTY
C	***ERROR MESSAGE AND QUIT THE DEBUG SYMBOL TABLE SCAN.
  200	PRINT 210, OPCODE, MODE
  210	FORMAT('0*** Error:  Inconsistent record sequence in the',
     1	    ' .EXE debug symbol table ***'/' ***',I4,',',I2,' ***')
	ERRFLG = .TRUE.
	CALL EXECLOSE
	RETURN
C
C
C	***WE HAVE A MODULE START RECORD--PICK UP THE LANGUAGE CODE AND THE
C	***MODULE NAME.  THEN SET THE MODE TO LOOK-FOR-ROUTINE MODE.  (FOR
C	***THIS RECORD, OPCODE = 188 DEC = BC HEX.)
  250	MODE = 2
	CALL EXESKIP(1)
	IF(ERRORFLG) GO TO 920
	CALL EXELONG(LANGUAGE)
	IF(ERRORFLG) GO TO 920
	CALL EXEASCIC(MODNAME)
	IF(ERRORFLG) GO TO 920
	MODSTART = 1
	MODEND = 0
	NESTING = 0
	NROUTS = 0
	NLINES = 0
	ROUTERR = .FALSE.
	GO TO 150
C
C	***WE HAVE A ROUTINE START RECORD WHEN WE ARE ALREADY WITHIN A ROUTINE.
C	***IF THE LANGUAGE IS MACRO, THIS IS SIMPLY THE START OF A NEW ROUTINE.
C	***OTHERWISE WE HAVE A NESTED ROUTINE, SO WE INCREMENT THE NESTING COUNT
C	***WHICH CAUSES THE NESTED ROUTINE TO APPEAR BEFORE ITS OUTER ROUTINES
C	***IN THE ROUTINE TABLE.  NESTED ROUTINES DO NOT OCCUR IN FORTRAN.  (FOR
C	***THIS RECORD, OPCODE = 190 DEC = BE HEX.)
  260	IF(LANGUAGE .EQ. 0) GO TO 270
	IF(LANGUAGE .EQ. 1) GO TO 200
	NESTING = NESTING + 1
C
C	***WE HAVE A ROUTINE START RECORD--PICK UP THE ROUTINE START ADDRESS
C	***AND THE ROUTINE NAME.  IF THIS IS A NESTED ROUTINE, INSERT IT BEFORE
C	***ITS OUTER ROUTINES IN THE ROUTINE TABLE.  ALSO SET THE MODE TO LOOK-
C	***FOR-LINE MODE AND INITIALIZE THE LINE NUMBER TABLE FOR THE ROUTINE.
C	***(FOR THIS RECORD, OPCODE = 190 DEC = BE HEX.)
  270	MODE = 3
	IF(ROUTKIND .EQ. 0 .AND. LINEKIND .EQ. 0) GO TO 180
	IF(NROUTS .GE. MAXROUTS) THEN
	    IF(.NOT. ROUTERR) PRINT 280, MODNAME
  280	    FORMAT('0*** Error:  Routine table overflow when reading',
     1		' .EXE file ***'/' ***         Some routines skipped',
     2		' in module ',A16,' ***')
	    ROUTERR = .TRUE.
	    NROUTS = NROUTS - 1
	    NLINES = ROUTLPTR(NROUTS)
	ENDIF
	NROUTS = NROUTS + 1
	IROUT = NROUTS
	IF(NESTING .GT. 0) THEN
	    DO 290 I=1,NESTING
	    ROUTNAME(IROUT) = ROUTNAME(IROUT - 1)
	    ROUTSTART(IROUT) = ROUTSTART(IROUT - 1)
	    IROUT = IROUT - 1
  290	    CONTINUE
	ENDIF
	CALL EXESKIP(1)
	IF(ERRORFLG) GO TO 920
	CALL EXELONG(ROUTSTART(IROUT))
	IF(ERRORFLG) GO TO 920
	CALL EXEASCIC(ROUTNAME(IROUT))
	IF(ERRORFLG) GO TO 920
	CURLINE = 1
	CURPC = ROUTSTART(IROUT)
	LINEINCR = 1
	LINEERR = .FALSE.
	BYTCNT = 0
	IF(NLINES .EQ. MAXLINES) GO TO 350
	NLINES = NLINES + 1
	LINETBL(NLINES) = 0
	PCTBL(NLINES) = CURPC
	GOTO 150
C
C	***WE HAVE A PROGRAM COUNTER/LINE NUMBER CORRELATION RECORD.  GENERATE
C	***LINE NUMBER TABLE ENTRIES FROM THIS RECORD.  (FOR THIS RECORD,
C	***OPCODE = 185 DEC = B9 HEX.)
  300	IF(LINEKIND .EQ. 0) GO TO 180
	BYTCNT = BYTCNT - 1
  310	IF(BYTCNT .LE. 0) GO TO 150
	CALL EXEBYTE(EQLONG)
	VALUE = EQBYTE
	BYTCNT = BYTCNT - 1
	IF(VALUE .LE. 0) THEN
	    IF(NLINES .EQ. MAXLINES) GO TO 350
	    IF(VALUE .NE. 0) NLINES = NLINES + 1
	    CURPC = CURPC - VALUE
	    LINETBL(NLINES) = CURLINE
	    PCTBL(NLINES) = CURPC
	    CURLINE = CURLINE + LINEINCR
	ELSE IF(VALUE .EQ. 1) THEN
	    CALL EXEWORD(VALUE)
	    IF(ERRORFLG) GO TO 920
	    BYTCNT = BYTCNT - 2
	    IF(NLINES .EQ. MAXLINES) GO TO 350
	    IF(VALUE .NE. 0) NLINES = NLINES + 1
	    CURPC = CURPC + VALUE
	    LINETBL(NLINES) = CURLINE
	    PCTBL(NLINES) = CURPC
	    CURLINE = CURLINE + LINEINCR
	ELSE IF(VALUE .EQ. 2) THEN
	    CALL EXEBYTE(VALUE)
	    IF(ERRORFLG) GO TO 920
	    BYTCNT = BYTCNT - 1
	    CURLINE = CURLINE + VALUE
	ELSE IF(VALUE .EQ. 3) THEN
	    CALL EXEWORD(VALUE)
	    IF(ERRORFLG) GO TO 920
	    BYTCNT = BYTCNT - 2
	    CURLINE = CURLINE + VALUE
	ELSE IF(VALUE .EQ. 4) THEN
	    CALL EXEBYTE(LINEINCR)
	    IF(ERRORFLG) GO TO 920
	    BYTCNT = BYTCNT - 1
	ELSE IF(VALUE .EQ. 5) THEN
	    CALL EXEWORD(LINEINCR)
	    IF(ERRORFLG) GO TO 920
	    BYTCNT = BYTCNT - 2
	ELSE IF(VALUE .EQ. 6) THEN
	    LINEINCR = 1
	ELSE
	    PRINT 330, MODNAME
  330	    FORMAT('0*** Error:  Invalid PC correlation table in .EXE',
     1		' file ***'/' ***         Bad module is ',A16,' ***')
	    ERRFLG = .TRUE.
	    CALL EXESKIP(BYTCNT)
	    IF(ERRORFLG) GO TO 920
	    GO TO 150
	ENDIF
	GO TO 310
C
C	***HANDLE THE LINE TABLE OVERFLOW ERROR.
  350	IF(.NOT. LINEERR) PRINT 360, MODNAME
  360	FORMAT('0*** Error:  Line table overflow in module ',A16,' ***')
	LINEERR = .TRUE.
	CALL EXESKIP(BYTCNT)
	IF(ERRORFLG) GO TO 920
	GO TO 150
C
C	***WE HAVE A ROUTINE END RECORD--PICK UP THE ROUTINE LENGTH, COMPUTE THE
C	***ROUTINE END ADDRESS, AND SET THE ENDING LINE TABLE POINTER.  IF THIS
C	***IS A NESTED ROUTINE, WE DECREMENT THE NESTING COUNT AND SET UP SOME
C	***VARIABLES (CURPC, LINETBL, ETC.) FOR THE OUTER ROUTINE.  THIS ASSUMES
C	***THAT THE OUTER ROUTINE WILL PHYSICALLY FOLLOW THE INNER ROUTINE.
C	***THIS RECORD DOES NOT OCCUR IF THE LANGUAGE IS MACRO.  (FOR THIS REC-
C	***ORD, OPCODE = 191 DEC = BF HEX.)
  400	IF(LANGUAGE .EQ. 0) GO TO 200
	IF(ROUTKIND .EQ. 0 .AND. LINEKIND .EQ. 0) THEN
	    IF(NESTING .EQ. 0) THEN
		MODE = 2
	    ELSE
		NESTING = NESTING - 1
	    ENDIF
	    GO TO 180
	ENDIF
	CALL EXESKIP(1)
	IF(ERRORFLG) GO TO 920
	CALL EXELONG(VALUE)
	IF(ERRORFLG) GO TO 920
	ROUTEND(NROUTS-NESTING) = ROUTSTART(NROUTS-NESTING) + VALUE - 1
	ROUTLPTR(NROUTS-NESTING) = NLINES
	IF(NESTING .EQ. 0) THEN
	    MODE = 2
	ELSE
	    NESTING = NESTING - 1
	    CURLINE = 1
	    CURPC = ROUTSTART(NROUTS-NESTING)
	    LINEINCR = 1
	    LINEERR = .FALSE.
	    BYTCNT = 0
	    IF(NLINES .EQ. MAXLINES) GO TO 350
	    NLINES = NLINES + 1
	    LINETBL(NLINES) = 0
	    PCTBL(NLINES) = CURPC
	ENDIF
	GO TO 150
C
C	***WE HAVE A PSECT NAME ENTRY.  SET THE MODULE START AND END ADDRESSES
C	***IF THIS IS THE PSECT SPECIFIED BY THE PSECTNAME PARAMETER.  THIS
C	***RECORD IS NECESSARY ONLY IF THE LANGUAGE IS MACRO--FOR ANY OTHER
C	***LANGUAGE, ROUTINE START AND END RECORDS CAN GIVE THE ADDRESS RANGE.
C	***(FOR THIS RECORD, OPCODE = 184 DEC = B8 HEX.)
  450	CALL EXESKIP(1)
	IF(ERRORFLG) GO TO 920
	CALL EXELONG(PSECTSTART)
	IF(ERRORFLG) GO TO 920
	CALL EXEASCIC(PSECTSTR)
	IF(ERRORFLG) GO TO 920
	CALL EXELONG(PSECTLEN)
	IF(ERRORFLG) GO TO 920
	IF(PSECTSTR .EQ. PSECTNAME) THEN
	    MODSTART = PSECTSTART
	    MODEND = PSECTSTART + PSECTLEN - 1
	ENDIF
	GO TO 150
C
C	***WE HAVE A MODULE END RECORD WITHOUT FIRST HAVING A ROUTINE END
C	***RECORD.  THIS IS LEGAL ONLY IF THE LANGUAGE IS MACRO.  (FOR THIS
C	***RECORD, OPCODE = 189 DEC = BD HEX.)
  500	IF(LANGUAGE .NE. 0) GO TO 200
	MODE = 1
	IF(MODSTART .GT. MODEND) GO TO 150
	NLINES = 0
C
C	***ELIMINATE ROUTINES NOT IN THE PROPER PSECT IN THE MODULE.
	I = 0
  510	I = I + 1
	IF(I .GT. NROUTS) GO TO 520
	IF(ROUTSTART(I) .GE. MODSTART .AND.
     1		ROUTSTART(I) .LE. MODEND) GO TO 510
	ROUTSTART(I) = ROUTSTART(NROUTS)
	NROUTS = NROUTS - 1
	I = I - 1
	GO TO 510
C
C	***SORT THE ROUTINES ON THEIR ADDRESSES AND SET THEIR END ADDRESSES.
  520	IF(NROUTS .EQ. 0) GO TO 600
	IF(NROUTS .GT. 1) THEN
	    DO 530 I = 1, NROUTS-1
	    DO 530 J = I+1, NROUTS
	    IF(ROUTSTART(J) .LT. ROUTSTART(I)) THEN
		VALUE = ROUTSTART(I)
		ROUTSTART(I) = ROUTSTART(J)
		ROUTSTART(J) = VALUE
		TEMPROUTNAME = ROUTNAME(I)
		ROUTNAME(I) = ROUTNAME(J)
		ROUTNAME(J) = TEMPROUTNAME
	    ENDIF
  530	    CONTINUE
	    DO 540 I = 1, NROUTS-1
	    ROUTEND(I) = ROUTSTART(I + 1) - 1
	    ROUTLPTR(I) = 0
  540	    CONTINUE
	ENDIF
	ROUTEND(NROUTS) = MODEND
	ROUTLPTR(NROUTS) = 0
	GO TO 600
C
C	***WE HAVE A MODULE END RECORD AFTER A ROUTINE END RECORD--THIS IS THE
C	***NORMAL SITUATION FOR ALL LANGUAGES EXCEPT MACRO.  MACRO COMES HERE
C	***ALSO IF THERE WERE NO ROUTINE START RECORDS AFTER THE MODULE START
C	***RECORD.  (FOR THIS RECORD, OPCODE = 189 DEC = BD HEX.)
  580	MODE = 1
	IF(MODSTART .GT. MODEND .AND. NROUTS .EQ. 0) GO TO 150
C
C
C	********************** BUILD UNIT TABLE ENTRIES ************************
C
C
C	***IF A PSECT ADDRESS RANGE WAS SPECIFIED FOR THE MODULE, ELIMINATE ALL
C	***ROUTINES WHICH ARE NOT IN THAT PSECT.
  600	IF(MODSTART .LE. MODEND .AND. NROUTS .GT. 0) THEN
	    DO 610 I=1,NROUTS
	    IF(ROUTSTART(I) .LT. MODSTART
     1		.OR. ROUTSTART(I) .GT. MODEND) ROUTNAME(I)(1:1) = ' '
  610	    CONTINUE
C
C	***OTHERWISE DETERMINE THE MODULE START AND END ADDRESSES FROM THE
C	***SMALLEST AND LARGEST ROUTINE ADDRESSES WITHIN THE MODULE.
	ELSE IF(MODSTART .GT. MODEND .AND. NROUTS .GT. 0) THEN
	    MODSTART = '7FFFFFFF'X
	    MODEND = '80000000'X
	    DO 620 I=1,NROUTS
	    MODSTART = MIN0(MODSTART, ROUTSTART(I))
	    MODEND = MAX0(MODEND, ROUTEND(I))
  620	    CONTINUE
	ENDIF
C
C	***FIND OR CREATE THE UNIT TABLE ENTRY FOR THIS MODULE.
	DO 630 IUNIT=0,NUNITS
	IF(UNITKIND(IUNIT) .EQ. MODKIND .AND.
     1		UNITTBL(IUNIT) .EQ. MODNAME) GO TO 650
  630	CONTINUE
	IF(NUNITS .EQ. MAXUNITS) THEN
	    PRINT 640, MODNAME
  640	    FORMAT('0*** Error:  Too many program units defined via',
     1		' EXE file ***'/' ***         This module ignored: ',
     2		A16,' ***')
	    ERRFLG = .TRUE.
	    GO TO 150
	ENDIF
	NUNITS = NUNITS + 1
	UNITKIND(NUNITS) = MODKIND
	UNITTBL(NUNITS) = MODNAME
	STEPSIZ(NUNITS) = '7FFFFFFF'X
	UNITLINEFLG(NUNITS) = .FALSE.
	IUNIT = NUNITS
  650	LOWADDR(IUNIT) = MODSTART
	HIADDR(IUNIT) = MODEND
	IF(NROUTS .EQ. 0) GO TO 150
C
C	***NOW WE CREATE A TEMPORARY UNIT TABLE FOR THIS MODULE.  WE DO SO BY
C	***FIRST COPYING OVER ALL UNIT TABLE ENTRIES FOR SUBUNITS OF THE MODULE
C	***TO THE TEMPORARY TABLE.  WHILE WE DO SO, WE INSERT THE LINE NUMBER
C	***ENTRIES UNDER THE CORRESPONDING ROUTINES.
	L1 = 1
	L2 = 0
	TPTR = 0
	LUNIT = IUNIT
C
C	***IF WE JUST COPIED OVER A ROUTINE ENTRY, COPY OVER THE CORRESPONDING
C	***LINE NUMBER ENTRIES IF THERE ARE ANY.
  680	IF(L1 .LE. L2 .AND. (LUNIT .EQ. NUNITS .OR.
     1		UNITKIND(LUNIT+1) .LE. MAX0(ROUTKIND,MODKIND))) THEN
	    DO 690 I=L1,L2
	    IF(LINETBL(I) .LT. 0) GO TO 690
	    IF(TPTR .EQ. MAXUNITS) GO TO 930
	    TPTR = TPTR + 1
	    TEMPNAME(TPTR) = GETEXESTRVAL(LINETBL(I))
	    TEMPTBL(1,TPTR) = LINEKIND
	    TEMPTBL(2,TPTR) = PCTBL(I)
	    TEMPTBL(3,TPTR) = PCTBL(I + 1) - 1
	    TEMPTBL(4,TPTR) = '7FFFFFFF'X
	    TEMPFLG(TPTR) = .FALSE.
	    LINETBL(I) = -1
  690	    CONTINUE
	    L1 = 1
	    L2 = 0
	ENDIF
C
C	***LEAVE THE UNIT TABLE LOOP IF THE SUBUNITS OF THIS MODULE ENDED.
	IF(LUNIT .EQ. NUNITS) GO TO 750
	IF(UNITKIND(LUNIT + 1) .LE. MODKIND) GO TO 750
	LUNIT = LUNIT + 1
C
C	***WE ARE STILL IN THE SAME MODULE--COPY THE CURRENT UNIT TABLE ENTRY
C	***OVER TO THE TEMPORARY UNIT TABLE.
	IF(TPTR .EQ. MAXUNITS) GO TO 930
	TPTR = TPTR + 1
	TEMPNAME(TPTR) = UNITTBL(LUNIT)
	TEMPTBL(1,TPTR) = UNITKIND(LUNIT)
	TEMPTBL(2,TPTR) = LOWADDR(LUNIT)
	TEMPTBL(3,TPTR) = HIADDR(LUNIT)
	TEMPTBL(4,TPTR) = STEPSIZ(LUNIT)
	TEMPFLG(TPTR) = UNITLINEFLG(LUNIT)
C
C	***IF THIS IS A ROUTINE ENTRY, GET ITS ADDRESS RANGE FROM THE .EXE
C	***FILE ROUTINE TABLE.  ALSO SET UP ITS LINE TABLE POINTERS.
	IF(UNITKIND(LUNIT) .EQ. ROUTKIND .AND. NROUTS .GT. 0) THEN
	    DO 700 I=1,NROUTS
	    IF(ROUTNAME(I) .EQ. UNITTBL(LUNIT)) GO TO 710
  700	    CONTINUE
	    GO TO 680
  710	    TEMPTBL(2,TPTR) = ROUTSTART(I)
	    TEMPTBL(3,TPTR) = ROUTEND(I)
	    L1 = ROUTLPTR(I - 1) + 1
	    L2 = ROUTLPTR(I) - 1
	    IF(LINEKIND .EQ. 0 .OR. LINESWITCH .EQ. 1 .OR.
     1		(LINESWITCH .EQ. 2 .AND. .NOT. UNITLINEFLG(IUNIT))) THEN
		L1 = 1
		L2 = 0
	    ENDIF
	    ROUTNAME(I)(1:1) = ' '
C
C	***IF THIS IS A LINE NUMBER ENTRY, PICK UP ITS ADDRESS RANGE FROM THE
C	***.EXE FILE LINE TABLE.
	ELSE IF(UNITKIND(LUNIT) .EQ. LINEKIND .AND. L1 .LE. L2) THEN
	    DO 720 I=L1,L2
	    IF(LINETBL(I) .LT. 0) GO TO 720
	    IF(GETEXESTRVAL(LINETBL(I)) .EQ. UNITTBL(LUNIT)) GO TO 730
  720	    CONTINUE
	    GO TO 680
  730	    TEMPTBL(2,TPTR) = PCTBL(I)
	    TEMPTBL(3,TPTR) = PCTBL(I + 1) - 1
	    LINETBL(I) = -1
	ENDIF
	GO TO 680
C
C	***THE UNIT TABLE ENTRIES UNDER THIS MODULE ENDED--NOW COPY ALL
C	***REMAINING ROUTINE AND LINE NUMBER ENTRIES FROM THE .EXE FILE
C	***TO THE TEMPORARY UNIT TABLE FOR THE MODULE.
  750	IF(NROUTS .EQ. 0) GO TO 800
	DO 770 I=1,NROUTS
	IF(ROUTNAME(I)(1:1) .EQ. ' ') GO TO 770
	IF(ROUTKIND .NE. 0) THEN
	    IF(TPTR .EQ. MAXUNITS) GO TO 930
	    TPTR = TPTR + 1
	    TEMPNAME(TPTR) = ROUTNAME(I)
	    TEMPTBL(1,TPTR) = ROUTKIND
	    TEMPTBL(2,TPTR) = ROUTSTART(I)
	    TEMPTBL(3,TPTR) = ROUTEND(I)
	    TEMPTBL(4,TPTR) = '7FFFFFFF'X
	    TEMPFLG(TPTR) = .FALSE.
	ENDIF
	IF((LINESWITCH .EQ. 2 .AND. .NOT. UNITLINEFLG(IUNIT)) .OR.
     1		LINESWITCH .EQ. 1 .OR. LINEKIND .EQ. 0) GO TO 770
	L1 = ROUTLPTR(I - 1) + 1
	L2 = ROUTLPTR(I) - 1
	IF(L1 .GT. L2) GO TO 770
	DO 760 J=L1,L2
	IF(TPTR .EQ. MAXUNITS) GO TO 930
	TPTR = TPTR + 1
	TEMPNAME(TPTR) = GETEXESTRVAL(LINETBL(J))
	TEMPTBL(1,TPTR) = LINEKIND
	TEMPTBL(2,TPTR) = PCTBL(J)
	TEMPTBL(3,TPTR) = PCTBL(J + 1) - 1
	TEMPTBL(4,TPTR) = '7FFFFFFF'X
	TEMPFLG(TPTR) = .FALSE.
  760	CONTINUE
  770	CONTINUE
C
C	***FINALLY MAKE ROOM IN THE REAL UNIT TABLE FOR ALL THE ENTRIES IN THE
C	***TEMPORARY UNIT TABLE--THEN COPY THE TEMPORARY ENTRIES TO THE PERMA-
C	***NENT UNIT TABLE.
  800	N = TPTR - (LUNIT - IUNIT)
	IF(N .GT. 0) THEN
	    I = NUNITS + N
	    IF(I .GT. MAXUNITS) GO TO 930
	    DO 810 J=NUNITS,LUNIT,-1
	    UNITKIND(I) = UNITKIND(J)
	    UNITTBL(I) = UNITTBL(J)
	    LOWADDR(I) = LOWADDR(J)
	    HIADDR(I) = HIADDR(J)
	    STEPSIZ(I) = STEPSIZ(J)
	    UNITLINEFLG(I) = UNITLINEFLG(J)
	    I = I - 1
  810	    CONTINUE
	    NUNITS = NUNITS + N
	ENDIF
	IF(TPTR .GT. 0) THEN
	    I = IUNIT
	    DO 820 J=1,TPTR
	    I = I + 1
	    UNITKIND(I) = TEMPTBL(1,J)
	    UNITTBL(I) = TEMPNAME(J)
	    LOWADDR(I) = TEMPTBL(2,J)
	    HIADDR(I) = TEMPTBL(3,J)
	    STEPSIZ(I) = TEMPTBL(4,J)
	    UNITLINEFLG(I) = TEMPFLG(J)
  820	    CONTINUE
	ENDIF
	GO TO 150
C
C
C	******************* CLEAN-UP AND ERROR HANDLERS **********************
C
C
C	***WE ARE ALL DONE WITH THE EXECUTABLE IMAGE DEBUG SYMBOL TABLE--NOW
C	***RETURN TO THE CALLER.
  900	OPCODE = 0
	IF(MODE .NE. 1) GO TO 200
	CALL EXECLOSE
	RETURN
C
C	***HANDLE ERRORS IN READING THE EXECUTABLE IMAGE FILE.
  920	ERRFLG = .TRUE.
	CALL EXECLOSE
	RETURN
C
C	***HANDLE UNIT TABLE OVERFLOW ERRORS.
  930	PRINT 640, MODNAME
	ERRFLG = .TRUE.
	CALL EXECLOSE
	RETURN
	END

	SUBROUTINE GETEXEFILE(EXENAME)
C
C
C	SUBROUTINES TO OPEN, ACCESS, AND CLOSE THE EXECUTABLE IMAGE FILE.  THE
C	FILE IS OPENED WITH THIS CALL:
C
C				CALL GETEXEFILE(EXENAME)
C
C	WHERE EXENAME CONTAINS THE NAME OF THE EXECUTABLE IMAGE FILE.  THIS
C	OPENS THE FILE AND DETERMINES THE LOCATION OF THE DEBUG SYMBOL TABLE
C	WITHIN THE FILE.  THE FILE POINTER IS POSITIONED TO THE START OF THAT
C	DEBUG SYMBOL TABLE.
C
C	TO RETRIEVE THE NEXT BYTE FROM THE DEBUG SYMBOL TABLE, AFTER THE .EXE
C	FILE HAS BEEN OPENED, THIS ENTRY POINT IS CALLED:
C
C				CALL EXEBYTE(VALUE)
C
C	WHERE VALUE IS THE RETURNED LONGWORD VALUE OF THE NEXT BYTE.  THE BYTE'S
C	VALUE IS RETURNED WITHOUT SIGN EXTENSION.  EXEBYTE ALSO ADVANCES THE
C	FILE POINTER BY ONE BYTE SO THAT CONSECUTIVE EXEBYTE CALLS RETRIEVE CON-
C	SECUTIVE BYTES FROM THE FILE.
C
C	TO PICK UP THE VALUE OF THE NEXT WORD (16 BITS) IN THE FILE, THIS ENTRY
C	POINT IS CALLED:
C
C				CALL EXEWORD(VALUE)
C
C	WHERE VALUE IS THE RETURNED LONGWORD VALUE.  THE VALUE IS RETURNED WITH-
C	OUT SIGN EXTENSION, AND THE FILE POINTER IS POSITIONED TO THE FIRST BYTE
C	AFTER THE RETRIEVED WORD.
C
C	TO PICK UP THE NEXT LONGWORD VALUE IN THE DEBUG SYMBOL TABLE, THIS ENTRY
C	POINT IS CALLED:
C
C				CALL EXELONG(VALUE)
C
C	WHERE AGAIN VALUE IS THE RETURNED LONGWORD VALUE.  HERE THE FILE POINTER
C	IS LEFT POINTING TO THE FIRST BYTE AFTER THE RETRIEVED LONGWORD.
C
C	TO PICK UP AN ASCIC (COUNTED ASCII) CHARACTER STRING FROM THE DEBUG
C	SYMBOL TABLE, THIS ENTRY POINT IS CALLED:
C
C				CALL EXEASCIC(NAMESTR)
C
C	WHERE NAMESTR IS THE RETURNED 16-CHARACTER STRING.  IF THE STRING IN THE
C	FILE IS LONGER THAN 16 CHARACTERS, IT IS TRUNCATED TO FIT IN NAMESTR.
C	THE FILE POINTER IS LEFT POINTING TO THE FIRST BYTE AFTER THE ASCIC
C	STRING.
C
C	TO SKIP OVER A SPECIFIED NUMBER OF BYTES IN THE FILE, THIS ENTRY POINT
C	IS CALLED:
C
C				CALL EXESKIP(VALUE)
C
C	WHERE VALUE SPECIFIES THE NUMBER OF BYTES OF DEBUG SYMBOL TABLE TO SKIP.
C	THIS IS USED TO SKIP OVER UNWANTED RECORDS IN THE FILE.  HERE VALUE MUST
C	BE IN THE RANGE 0 - 512.
C
C	TO TEST WHETHER THE DEBUG SYMBOL TABLE HAS ENDED, I.E. WHETHER THE FILE
C	POINTER IS POSITIONED PAST THE LAST BYTE OF THE DEBUG SYMBOL TABLE, THIS
C	ENTRY POINT IS CALLED:
C
C				CALL EXEEOF(EOFFLG)
C
C	WHERE EOFFLG IS RETURNED .TRUE. IF THE DEBUG SYMBOL TABLE HAS ENDED AND
C	.FALSE. IF IT HAS NOT.  EXEEOF HAS NO EFFECT ON THE FILE POINTER.
C
C	FINALLY, TO CLOSE THE EXECUTABLE IMAGE FILE, THIS ENTRY POINT IS CALLED:
C
C				CALL EXECLOSE
C
C
C	ON ERRORS, THESE ENTRY POINTS PRINT AN ERROR MESSAGE AND RETURN WITH
C	THE COMMON VARIABLE ERRORFLG SET TO .TRUE..  IF THE ERROR FLAG IS SET,
C	NO VALUE IS RETURNED TO THE CALLER.
C
C
C	***DEFINE DATA AREAS
	IMPLICIT INTEGER (A - Z)
	COMMON/EXECOM/ ERRORFLG
	LOGICAL ERRORFLG, EOFFLG
	CHARACTER*40 EXENAME
	CHARACTER*16 NAMESTR, EQCHAR
	BYTE EXEBUF(0:511), EQBYTE(0:15)
	INTEGER*4 EQLONG
	EQUIVALENCE (EQBYTE(0),EQLONG), (EQBYTE(0),EQCHAR)
C
C
C	***OPEN THE EXECUTABLE IMAGE FILE AND READ IN ITS HEADER RECORD.
	OPEN(UNIT=8, NAME=EXENAME, TYPE='OLD', READONLY, ACCESS='DIRECT',
     1	    FORM='UNFORMATTED', RECORDTYPE='FIXED', BLOCKSIZE=512,
     2	    ERR=100)
	READ(8'1,ERR=120) EXEBUF
	EQLONG = 0
	EQBYTE(0) = EXEBUF(4)
	EQBYTE(1) = EXEBUF(5)
	BUFPTR = EQLONG
	IF(BUFPTR .GT. 512 - 10) STOP '--> ERROR 1 IN GETEXEFILE'
C
C	***PICK UP THE VIRTUAL BLOCK NUMBER RANGE OF THE DEBUG SYMBOL TABLE
C	***FROM THE EXECUTABLE IMAGE HEADER RECORD.
	EQBYTE(0) = EXEBUF(BUFPTR)
	EQBYTE(1) = EXEBUF(BUFPTR + 1)
	EQBYTE(2) = EXEBUF(BUFPTR + 2)
	EQBYTE(3) = EXEBUF(BUFPTR + 3)
	BLKNUM = EQLONG
	IF(BLKNUM .EQ. 0) STOP '--> ERROR 2 IN GETEXEFILE'
	EQLONG = 0
	EQBYTE(0) = EXEBUF(BUFPTR + 8)
	EQBYTE(1) = EXEBUF(BUFPTR + 9)
	MAXBLKNUM = BLKNUM + EQLONG - 1
	IF(MAXBLKNUM .LT. BLKNUM) STOP '--> ERROR 3 IN GETEXEFILE'
C
C	***SET THE BUFFER POINTER SO THAT WE AUTOMATICALLY READ IN THE FIRST DE-
C	***BUG SYMBOL TABLE BLOCK WHEN ONE OF THE OTHER ENTRY POINTS IS CALLED.
	BUFPTR = 512
	RETURN
C
C
C	*** EXEBYTE ENTRY POINT--PICK UP THE NEXT BYTE OF DEBUG INFO.
	ENTRY EXEBYTE(VALUE)
	NBYTES = 1
	GO TO 20
C
C	*** EXEWORD ENTRY POINT--PICK UP THE NEXT WORD (16 BITS) OF DEBUG INFO.
	ENTRY EXEWORD(VALUE)
	NBYTES = 2
	GO TO 20
C
C	*** EXELONG ENTRY POINT--PICK UP THE NEXT LONGWORD OF DEBUG INFO.
	ENTRY EXELONG(VALUE)
	NBYTES = 4
C
C	***IF NECESSARY, BRING IN THE NEXT BLOCK OF THE DEBUG SYMBOL TABLE FROM
C	***THE EXECUTABLE IMAGE FILE.  THEN PICK UP THE NEXT 1, 2, OR 4 BYTES
C	***WITHOUT SIGN EXTENSION.
   20	ERRORFLG = .FALSE.
	EQLONG = 0
	DO 40 I=1,NBYTES
	IF(BUFPTR .GE. 512) THEN
	    IF(BLKNUM .GT. MAXBLKNUM) GO TO 160
	    READ(8'BLKNUM,ERR=140) EXEBUF
	    BLKNUM = BLKNUM + 1
	    BUFPTR = 0
	ENDIF
	EQBYTE(I - 1) = EXEBUF(BUFPTR)
	BUFPTR = BUFPTR + 1
   40	CONTINUE
	VALUE = EQLONG
	RETURN
C
C
C	*** EXEASCIC ENTRY POINT--PICK UP THE NEXT COUNTED ASCII CHARACTER
C	***STRING AND RETURN IT EXPANDED OR TRUNCATED TO 16 CHARACTERS.
	ENTRY EXEASCIC(NAMESTR)
	ERRORFLG = .FALSE.
	EQLONG = 0
	IF(BUFPTR .GE. 512) THEN
	    IF(BLKNUM .GT. MAXBLKNUM) GO TO 160
	    READ(8'BLKNUM,ERR=140) EXEBUF
	    BLKNUM = BLKNUM + 1
	    BUFPTR = 0
	ENDIF
	EQBYTE(0) = EXEBUF(BUFPTR)
	BUFPTR = BUFPTR + 1
	NCHARS = EQLONG
	EQCHAR = ' '
	DO 60 I=1,NCHARS
	IF(BUFPTR .GE. 512) THEN
	    IF(BLKNUM .GT. MAXBLKNUM) GO TO 160
	    READ(8'BLKNUM,ERR=140) EXEBUF
	    BLKNUM = BLKNUM + 1
	    BUFPTR = 0
	ENDIF
	IF(I .LE. 16) EQBYTE(I - 1) = EXEBUF(BUFPTR)
	BUFPTR = BUFPTR + 1
   60	CONTINUE
	NAMESTR = EQCHAR
	RETURN
C
C
C	*** EXESKIP ENTRY POINT--SKIP THE NEXT VALUE BYTES OF THE .EXE FILE.
C	***HERE WE ASSUME THAT 0 <= VALUE <= 512.
	ENTRY EXESKIP(VALUE)
	BUFPTR = BUFPTR + VALUE
	IF(BUFPTR .GT. 512) THEN
	    IF(BLKNUM .GT. MAXBLKNUM) GO TO 160
	    READ(8'BLKNUM,ERR=140) EXEBUF
	    BLKNUM = BLKNUM + 1
	    BUFPTR = BUFPTR - 512
	ENDIF
	RETURN
C
C
C	*** EXEEOF ENTRY POINT--CHECK FOR END OF DEBUG SYMBOL TABLE.
	ENTRY EXEEOF(EOFFLG)
	EOFFLG = BUFPTR .EQ. 512 .AND. BLKNUM .GT. MAXBLKNUM
	RETURN
C
C
C	*** EXECLOSE ENTRY POINT--CLOSE OUT THE EXECUTABLE IMAGE FILE.
	ENTRY EXECLOSE
	CLOSE(UNIT=8)
	RETURN
C
C
C	***HANDLE VARIOUS ERROR CONDITIONS--GIVE A NASTY MESSAGE, SET THE
C	***ERROR FLAG, AND RETURN.
  100	PRINT 110
  110	FORMAT('0*** Error:  Executable image file could not be opened',
     1		' ***')
	ERRORFLG = .TRUE.
	RETURN
C
  120	PRINT 130
  130	FORMAT('0*** Error:  I/O error reading .EXE file header',
     1		' record ***')
	ERRORFLG = .TRUE.
	CLOSE(UNIT=8)
	RETURN
C
  140	PRINT 150
  150	FORMAT('0*** Error:  I/O error reading traceback info in',
     1		' .EXE file ***')
	ERRORFLG = .TRUE.
	RETURN
C
  160	PRINT 170
  170	FORMAT('0*** Error:  Premature End-of-file on .EXE file ***')
	ERRORFLG = .TRUE.
	RETURN
	END

	CHARACTER*16 FUNCTION GETEXESTRVAL(VALUE)
C
C
C	STRING FUNCTION WHICH RETURNS A POSITIVE INTEGER VALUE AS A CHARACTER
C	STRING.  THIS FUNCTION, WHICH IS USED TO CONVERT INTEGER LINE NUMBERS
C	TO CHARACTER LINE NAMES, IS CALLED AS FOLLOWS:
C
C			CHAR = GETEXESTRVAL(VALUE)
C
C	WHERE VALUE IS THE INTEGER VALUE TO BE CONVERTED AND CHAR RECEIVES THE
C	RETURNED CHARACTER VALUE.
C
C
C	***DEFINE DATA AREAS.
	IMPLICIT INTEGER (A - Z)
	DIMENSION DIGVAL(1:16), DIGITS(0:9)
	CHARACTER*1 DIGITS
	DATA DIGITS/'0','1','2','3','4','5','6','7','8','9'/
C
C	***EXTRACT THE DIGIT VALUES BY REPEATED DIVISION BY TEN.
	NUM = VALUE
	N = 0
  10	IF(NUM .LE. 0) GO TO 20
	N = N + 1
	OLDNUM = NUM
	NUM = NUM/10
	DIGVAL(N) = OLDNUM - NUM*10
	GO TO 10
C
C	***CONSTRUCT THE RETURNED CHARACTER STRING--THEN RETURN.
   20	GETEXESTRVAL = '0'
	IF(N .GT. 0) THEN
	    J = N
	    DO 30 I=1,N
	    GETEXESTRVAL(I:I) = DIGITS(DIGVAL(J))
	    J = J - 1
   30	    CONTINUE
	ENDIF
	RETURN
	END

	SUBROUTINE GETHEX
C
C
C	SUBROUTINE TO PICK UP A HEXADECIMAL NUMBER FROM THE USER'S INPUT IMAGE.
C	THE ROUTINE IS CALLED AS FOLLOWS:
C
C				CALL GETHEX
C
C	GETHEX USES THE FOLLOWING COMMON VARIABLES:
C
C	*** IMAGE	= THE USER'S INPUT IMAGE TO BE SCANNED.
C	*** IMPTR	= SCAN POINTER INTO THE INPUT IMAGE.
C	*** IMNUM	= THE IMAGE NUMBER (IMAGE NUMBERS START AT 1).
C	*** HEXNUM	= THE RETURNED VALUE OF THE HEXADECIMAL NUMBER.
C	*** NAMPTR	= THE RETURNED POINTER TO THE FIRST CHARACTER OF
C			  THE HEXADECIMAL NUMBER.
C	*** ERRFLG	= THE RETURNED ERROR FLAG.
C
C	ON ERRORS (NUMBER TOO LARGE OR NO NUMBER FOUND), GETHEX GIVES AN ERROR
C	MESSAGE AND RETURNS WITH ERRFLG = .TRUE..
C
C
C	***DATA DECLARATIONS
	INCLUDE 'PMECOMMON.FOR/NOLIST'
C
	DIMENSION XLATE(0:255)
	DATA XLATE/48*20, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 7*20, 10, 11, 12,
     1		13, 14, 15, 26*20, 10, 11, 12, 13, 14, 15, 25*20, 128*20/
C
C	***INITIALIZE THE OUTPUT VALUE TO ZERO AND SCAN PAST ANY LEADING BLANKS.
	ERRFLG = .FALSE.
	HEXNUM = 0
	NUMLEN = 0
   10	NAMPTR = IMPTR
	IF(IMAGE(IMPTR:IMPTR) .NE. ' ') GO TO 20
	IMPTR = IMPTR + 1
	GO TO 10
C
C	***NOW PICK UP THE VALUE OF THE HEXADECIMAL NUMBER
   20	DIGIT = XLATE(ICHAR(IMAGE(IMPTR:IMPTR)))
	IF(DIGIT .EQ. 20) GO TO 30
	IF(NUMLEN .EQ. 8) GO TO 50
	IF(HEXNUM .EQ. 0) NUMLEN = 0
	HEXNUM = IOR(ISHFT(HEXNUM,4), DIGIT)
	NUMLEN = NUMLEN + 1
	IMPTR = IMPTR + 1
	GO TO 20
C
C	***FINALLY SCAN PAST ANY TRAILING BLANKS AND RETURN
   30	IF(NUMLEN .EQ. 0) GO TO 70
   40	IF(IMAGE(IMPTR:IMPTR) .NE. ' ') RETURN
	IMPTR = IMPTR + 1
	GO TO 40
C
C	***NUMBER IS TOO LARGE TO FIT IN ONE LONGWORD--GIVE AN ERROR MESSAGE
   50	PRINT 60, IMNUM, IMAGE
   60	FORMAT('0',I4,': ',A72/1X,<IMPTR+5>('-'),'!'/
     1	    ' *** Error:  Hexadecimal value is too large ***')
	ERRFLG = .TRUE.
	RETURN
C
C	***NO HEX DIGIT WAS FOUND AT ALL--GIVE AN ERROR MESSAGE
   70	PRINT 80, IMNUM, IMAGE
   80	FORMAT('0',I4,': ',A72/1X,<IMPTR+5>('-'),'!'/' *** Error:  ',
     1	    'Missing hex digit or invalid character in number ***')
	ERRFLG = .TRUE.
	RETURN
	END

	SUBROUTINE GETMAP(MAPNAME,PSECTNAME)
C
C
C	SUBROUTINE TO PICK UP ADDRESS RANGES FOR PROGRAM UNITS BY SCANNING A
C	SPECIFIED LINKER .MAP LISTING.  THE SUBROUTINE IS CALLED AS FOLLOWS:
C
C			CALL GETMAP(MAPNAME,PSECTNAME)
C
C	WHERE MAPNAME IS THE FILE NAME OF THE .MAP FILE TO BE SCANNED AND 
C	PSECTNAME IS THE NAME OF THE PSECT WHOSE ADDRESS RANGES ARE TO BE USED.
C
C
C	***DEFINE DATA AREAS
	INCLUDE 'PMECOMMON.FOR/NOLIST'
C
	CHARACTER*16 PSECTNAME
	CHARACTER*40 MAPNAME
	LOGICAL SKIPFLG
C
C	***DETERMINE WHICH KIND TABLE ENTRY REFERS TO MODULES
	ERRFLG = .FALSE.
	DO 10 MODKIND=0,NKINDS
	IF(KINDTBL(MODKIND) .EQ. 'MODULE') GO TO 40
   10	CONTINUE
	PRINT 20, IMNUM, IMAGE
   20	FORMAT('0',I4,': ',A72/' ***Error:  Program kind MODULE must',
     1		' exist to use DEFINE ADDRESSES: MAP ***')
	ERRFLG = .TRUE.
	RETURN
C
C	***NOW OPEN THE MAP FILE
   40	OPEN(UNIT=3, NAME=MAPNAME, TYPE='OLD', ERR=220)
C
C	***SCAN THE MAP LISTING FOR THE START OF THE PROGRAM SECTION SYNOPSIS
   50	READ(3,60,END=240) IMAGE
   60	FORMAT(A72)
	IF(IMAGE(47:70) .NE. 'PROGRAM SECTION SYNOPSIS') GO TO 50
C
C	***WE GOT THERE--NOW SEARCH FOR THE DESIRED PSECT NAME
	SKIPFLG = .TRUE.
   80	READ(3,60,END=200) IMAGE
	IF(IMAGE(48:69) .EQ. 'SYMBOL CROSS REFERENCE') GO TO 200
	IF(IMAGE(52:65) .EQ. 'IMAGE SYNOPSIS') GO TO 200
	IF(IMAGE(60:60) .NE. '(') GO TO 80
	IF(IMAGE(1:16) .EQ. PSECTNAME) THEN
	    SKIPFLG = .FALSE.
	    GO TO 80
	ELSE IF(IMAGE(1:16) .NE. ' ') THEN
	    SKIPFLG = .TRUE.
	    GO TO 80
	ENDIF
	IF(SKIPFLG) GO TO 80
C
C	***WE ARE NOW AT THE RIGHT PSECT--GET THE NEXT MODULE LISTED THEREIN
	NAME = IMAGE(17:32)
	DO 100 IUNIT=0,NUNITS
	IF(UNITKIND(IUNIT) .EQ. MODKIND .AND.
     1		UNITTBL(IUNIT) .EQ. NAME) GO TO 120
  100	CONTINUE
C
C	***THE MODULE DOES NOT EXIST IN THE UNIT TABLE--CREATE A NEW UNIT TABLE
C	***ENTRY FOR IT
	IF(NUNITS .EQ. MAXUNITS) THEN
	    PRINT 110, NAME
  110	    FORMAT('0*** Error:  Too many program units defined via',
     1		' MAP file ***'/' ***         This module ignored: ',
     2		A16,' ***')
	    ERRFLG = .TRUE.
	    GO TO 80
	ENDIF
	NUNITS = NUNITS + 1
	UNITKIND(NUNITS) = MODKIND
	UNITTBL(NUNITS) = NAME
	LOWADDR(NUNITS) = 1
	HIADDR(NUNITS) = 0
	STEPSIZ(NUNITS) = '7FFFFFFF'X
	UNITLINEFLG(NUNITS) = .FALSE.
	IUNIT = NUNITS
C
C	***NOW EXTRACT THE MODULE START AND END ADDRESSES FROM THE IMAGE
  120	IMAGE(73:74) = '!!'
	IMPTR = 33
	CALL GETHEX
	IF(ERRFLG) GO TO 80
	LOWHEX = HEXNUM
	CALL GETHEX
	IF(ERRFLG) GO TO 80
	HIHEX = HEXNUM
	IF(LOWHEX.GT.HIHEX .OR. (LOWHEX.LT.0 .AND. HIHEX.GE.0)) THEN
	    PRINT 130, NAME
  130	    FORMAT('0*** Error:  Invalid address range for module ',
     1		A16,' ***')
	    ERRFLG = .TRUE.
	    GO TO 80
	ENDIF
	LOWADDR(IUNIT) = LOWHEX
	HIADDR(IUNIT) = HIHEX
	GO TO 80
C
C	***THE PROGRAM SECTION SYNOPSIS ENDED--CLOSE THE MAP FILE AND RETURN
  200	CLOSE(UNIT=3)
	RETURN
C
C	***HANDLE OPEN ERROR ON THE MAP FILE--GIVE A MESSAGE AND RETURN
  220	PRINT 230, IMNUM, IMAGE
  230	FORMAT('0',I4,': ',A72/' *** Error:  MAP file could not be',
     1		' opened ***')
	ERRFLG = .TRUE.
	RETURN
C
C	***WE NEVER FOUND THE PROGRAM SECTION SYNOPSIS--THIS MAY NOT BE A VALID
C	***MAP FILE, SO GIVE AN ERROR MESSAGE BEFORE RETURNING
  240	PRINT 250
  250	FORMAT('0*** Error:  No Program Section Synopsis found in MAP',
     1	    ' file ***')
	ERRFLG = .TRUE.
	CLOSE(UNIT=3)
	RETURN
	END

	SUBROUTINE GETNAME
C
C
C	SUBROUTINE TO PICK UP A NAME FROM THE USER'S INPUT IMAGE.  A NAME IS
C	DEFINED AS A STRING OF 1 - 16 CHARACTERS FROM THE SET A - Z, 0 - 9, $,
C	_, AND a - z, WITH LOWER-CASE LETTERS TRANSLATED TO UPPER CASE.  THE
C	SUBROUTINE IS CALLED AS FOLLOWS:
C
C				CALL GETNAME
C
C	AND USES THE FOLLOWING COMMON VARIABLES:
C
C	*** IMAGE	= THE USER'S INPUT IMAGE TO BE SCANNED.
C	*** IMPTR	= SCAN POINTER INTO THE INPUT IMAGE.
C	*** IMNUM	= THE IMAGE NUMBER (IMAGE NUMBERS START AT 1).
C	*** NAME	= THE RETURNED NAME STRING.
C	*** NAMLEN	= THE RETURNED LENGTH IN CHARACTERS OF THE NAME.
C	*** NAMPTR	= THE RETURNED POINTER TO THE FIRST CHARACTER OF
C			  THE NAME.
C	*** ERRFLG	= THE RETURNED ERROR FLAG.
C
C	ON ERRORS (NAME TOO LONG OR NO NAME FOUND), GETNAME PRINTS AN ERROR
C	MESSAGE AND RETURNS WITH ERRFLG = .TRUE..
C
C
C	***DATA DECLARATIONS
	INCLUDE 'PMECOMMON/NOLIST'
C
	CHARACTER*1 XLATE, NXTCHAR
	DIMENSION XLATE(0:255)
	DATA XLATE/36*' ', '$', 11*' ', '0', '1', '2', '3', '4',
     1		'5', '6', '7', '8', '9', 7*' ', 'A', 'B', 'C', 'D', 'E',
     2		'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q',
     3		'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 4*' ', '_', 1*' ',
     4		'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L',
     5		'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',
     6		'Y', 'Z', 5*' ', 128*' '/
C
C	***INITIALIZE THE OUTPUT NAME TO BLANKS AND SCAN PAST ANY LEADING BLANKS
C	***IN THE INPUT IMAGE.
	ERRFLG = .FALSE.
	NAME = ' '
	NAMLEN = 0
   10	NAMPTR = IMPTR
	IF(IMAGE(IMPTR:IMPTR) .NE. ' ') GO TO 20
	IMPTR = IMPTR + 1
	GO TO 10
C
C	***NOW PICK UP ALL THE CHARACTERS IN THE NAME, TRANSLATING ALL LETTERS
C	***TO UPPER CASE AS WE GO ALONG.
   20	NXTCHAR = XLATE(ICHAR(IMAGE(IMPTR:IMPTR)))
	IF(NXTCHAR .EQ. ' ') GO TO 30
	IF(NAMLEN .EQ. 16) GO TO 50
	IMPTR = IMPTR + 1
	NAMLEN = NAMLEN + 1
	NAME(NAMLEN:NAMLEN) = NXTCHAR
	GO TO 20
C
C	***FINALLY SCAN PAST ANY TRAILING BLANKS AND RETURN
   30	IF(NAMLEN .EQ. 0) GO TO 70
   40	IF(IMAGE(IMPTR:IMPTR) .NE. ' ') RETURN
	IMPTR = IMPTR + 1
	GO TO 40
C
C	***NAME TOO LONG--GIVE AN ERROR MESSAGE
   50	PRINT 60, IMNUM, IMAGE
   60	FORMAT('0',I4,': ',A72/1X,<IMPTR+5>('-'),'!'/
     1	    ' *** Error:  Name longer than 16 characters ***')
	ERRFLG = .TRUE.
	RETURN
C
C	***NO NAME WAS FOUND--GIVE AN ERROR MESSAGE
   70	PRINT 80, IMNUM, IMAGE
   80	FORMAT('0',I4,': ',A72/1X,<IMPTR+5>('-'),'!'/
     1	    ' *** Error:  Name missing or invalid character in name ***')
	ERRFLG = .TRUE.
	RETURN
	END

	SUBROUTINE GETRANGE(IUNIT, LOW, HIGH, STEP)
C
C
C	SUBROUTINE TO GET THE ADDRESS RANGE OF A SPECIFIED PROGRAM UNIT.  IT IS
C	CALLED AS FOLLOWS:
C
C			CALL GETRANGE(IUNIT, LOW, HIGH, STEP)
C
C	WHERE IUNIT IS A POINTER TO THE PROGRAM UNIT (AS REPRESENTED BY UNITTBL)
C	WHOSE ADDRESS RANGE IS TO BE DETERMINED.  LOW IS THE RETURNED LOW
C	ADDRESS OF THE RANGE AND HIGH IS THE RETURNED HIGH ADDRESS OF THE
C	ADDRESS RANGE.  STEP IS THE RETURNED STEP SIZE (BUCKET SIZE) FOR THE
C	SPECIFIED PROGRAM UNIT.
C
C	IF NO ADDRESS RANGE CAN BE DETERMINED, ERRFLG = .TRUE. AND LOW = 1 ON
C	RETURN.  SIMILARLY, IF THE FOUND ADDRESS RANGE IS INVALID (BOTH POSI-
C	TIVE AND NEGATIVE ADDRESSES), ERRFLG = .TRUE. AND LOW = 2 ON RETURN.
C
C
C	***DATA DEFINITIONS
	INCLUDE 'PMECOMMON.FOR/NOLIST'
C
C	***FIRST DETERMINE IF THE ADDRESS RANGE HAS BEEN DIRECTLY SPECIFIED FOR
C	***THIS PROGRAM UNIT.  IF NOT, GIVE THE UNIT AN INVERTED RANGE.
	ERRFLG = .FALSE.
	IF(LOWADDR(IUNIT) .LE. HIADDR(IUNIT)) THEN
	    LOW = LOWADDR(IUNIT)
	    HIGH = HIADDR(IUNIT)
	ELSE
	    LOW = '7FFFFFFF'X
	    HIGH = '80000000'X
	ENDIF
C
C	***THEN EXPAND THE PROGRAM UNIT'S ADDRESS RANGE (IF NECESSARY) SO IT
C	***INCLUDES THE HIGHEST AND THE LOWEST ADDRESSES FOUND AMONG ALL ITS
C	***SUBUNITS' ADDRESS RANGES.
	IKIND = UNITKIND(IUNIT)
	I = IUNIT
   10	I = I + 1
	IF(I .GT. NUNITS) GO TO 20
	IF(UNITKIND(I) .LE. IKIND) GO TO 20
	IF(LOWADDR(I) .LE. HIADDR(I)) THEN
	    LOW = MIN0(LOW, LOWADDR(I))
	    HIGH = MAX0(HIGH, HIADDR(I))
	ENDIF
	GO TO 10
C
C	***IF NO ADDRESS RANGE WAS FOUND, SET THE ERROR FLAG AND RETURN WITH
C	***LOW = 1.
   20	IF(LOW .GT. HIGH) THEN
	    ERRFLG = .TRUE.
	    LOW = 1
	    RETURN
	ENDIF
C
C	***IF THE ADDRESS RANGE IS INVALID (I.E., SPANS BOTH POSITIVE AND NEGA-
C	***TIVE ADDRESSES), SET THE ERROR FLAG AND RETURN WITH LOW = 2.
	IF(LOW .LT. 0 .AND. HIGH .GE. 0) THEN
	    ERRFLG = .TRUE.
	    LOW = 2
	    RETURN
	ENDIF
C
C	***THE ADDRESS RANGE IS VALID--NOW DETERMINE THE STEP SIZE AND RETURN.
	STEP = HIGH - LOW
	IF(STEPSIZ(IUNIT) .LE. STEP) THEN
	    STEP = STEPSIZ(IUNIT)
	ELSE
	    STEP = STEP + 1
	ENDIF
	RETURN
	END

	SUBROUTINE MAKEFILE
C
C
C	SUBROUTINE TO CONSTRUCT AND WRITE OUT A NEW BUCKET FILE.  THE ROUTINE
C	IS CALLED AS FOLLOWS:
C
C				CALL MAKEFILE
C
C	THE ROUTINE BUILDS A WHOLE BUCKET FILE IN THE LOCAL BUFFER AREA BUFFER.
C	ALL NEEDED INFORMATION IS EXTRACTED FROM THE DATACOM AND CHARCOM COMMON
C	BLOCKS.  THIS BUCKET IS THEN WRITTEN OUT INTO A NEW FILE THROUGH A CALL
C	ON SUBROUTINE PME_CLOSE.
C
C	IF THE BUCKET FILE CANNOT BE CREATED, EITHER BECAUSE NO SAMPLING INFOR-
C	MATION WAS SPECIFIED OR BECAUSE THE BUFFER OVERFLOWS, MAKEFILE RETURNS
C	WITH ERRFLG = .TRUE..
C
C
C	***DATA DEFINITIONS
	INCLUDE 'PMECOMMON.FOR/NOLIST'
	INCLUDE 'PMECOMDEF.FOR/NOLIST'
C
	PARAMETER MAXBUF = 16383
	DIMENSION BUFFER(0:MAXBUF)
C
C	***SPECIAL EQUIVALENCING SO WE CAN COPY A CHARACTER STRING FROM A
C	***CHARACTER VARIABLE TO THE INTEGER BUFFER.
	CHARACTER*60 CHRNAME
	BYTE BYTNAME(60)
	DIMENSION INTNAME(15)
	EQUIVALENCE (CHRNAME,BYTNAME(1)), (BYTNAME(1),INTNAME(1))
C
C
C	***FIRST MAKE SURE WE HAVE SOME SAMPLING GROUPS TO PUT OUT
	ERRFLG = .FALSE.
	IF(NGRPS .EQ. 0) THEN
	    PRINT 10
   10	    FORMAT('0*** Error: No sampling groups were specified ***'/
     1		   ' ***        Hence no Bucket File can be built ***')
	    ERRFLG = .TRUE.
	    RETURN
	ENDIF
C
C	***BUILD THE FILE HEADER RECORD IN BUFFER AND INITIALIZE VARIOUS
C	***BUFFER POINTERS.  (NOTE THAT ALL POINTERS IN THE FILE ARE BYTE
C	***OFFSETS, NOT LONGWORD OFFSETS.)
	GRPPTR = HDRRECSIZ
	INDXPTR = GRPPTR + (NGRPS + 1)*GRPRECSIZ
	BRECPTR = INDXPTR
	DO 30 I=1,NGRPS
   30	BRECPTR = BRECPTR + GRPNBKTS(I)
	IF(BRECPTR + 2*BKTRECSIZ .GE. MAXBUF) GO TO 300
	BUFFER(HDRFLAGS) = FLAGBITS
	BUFFER(HDRNUMRUNS) = -1
	BUFFER(HDRDEFCNTR) = 0
	BUFFER(HDRNUMBKTS) = NBKTS
	BUFFER(HDRBGRPTR) = GRPPTR*4
	BUFFER(HDRINDXPTR) = INDXPTR*4
	BUFFER(HDRBRECPTR) = BRECPTR*4
C
C	***BUILD A FIRST BUCKET RECORD WITH AN INVERTED ADDRESS RANGE.  NULL
C	***INDEX TABLE POINTERS WILL POINT TO THIS BUCKET RECORD.
	BUFFER(BRECPTR+FLINK) = 0
	BUFFER(BRECPTR+BKTLOWBND) = 1
	BUFFER(BRECPTR+BKTHIBND) = 0
	BUFFER(BRECPTR+COUNT) = 0
	BUFFER(BRECPTR+BUCKETNUM) = 0
	BRECPTR = BRECPTR + BKTRECSIZ
C
C	***NOW GO THROUGH THE BUCKET GROUPS, AND FOR EACH ONE, BUILD THE BUCKET
C	***GROUP RECORD, THE INDEX TABLE, AND THE BUCKET RECORDS.  HERE WE WILL
C	***START WITH THE BUCKET GROUP RECORD.
	DO 100 IGRP=1,NGRPS
	BUFFER(GRPPTR+GRPLOWBND) = GRPLOW(IGRP)
	BUFFER(GRPPTR+GRPHIBND) = GRPHIGH(IGRP)
	BUFFER(GRPPTR+BUCKETSIZE) = GRPSTEP(IGRP)
	BUFFER(GRPPTR+RELTBLPTR) = INDXPTR*4
	BUFFER(GRPPTR+ABSTBLPTR) = 0
	CHRNAME = GRPNAMSTR(IGRP)
	DO 50 I=1,15
   50	BUFFER(GRPPTR+GRPNAME+I-1) = INTNAME(I)
C
C	***NOW CLEAR THIS BUCKET GROUP'S INDEX TABLE.
	DO 60 I = INDXPTR, INDXPTR+GRPNBKTS(IGRP)-1
   60	BUFFER(I) = 0
C
C	***THEN GO THROUGH THE GROUP'S BUCKET TABLE ENTRIES AND CREATE EACH
C	***BUCKET'S INDEX TABLE POINTERS AND BUCKET RECORDS.
	DO 80 IBKT = GRPLOPTR(IGRP), GRPHIPTR(IGRP)
	ILO = (BKTLOW(IBKT) - GRPLOW(IGRP))/GRPSTEP(IGRP) + INDXPTR
	IHI = (BKTHIGH(IBKT) - GRPLOW(IGRP))/GRPSTEP(IGRP) + INDXPTR
	DO 80 I=ILO,IHI
	IF(BRECPTR + BKTRECSIZ .GE. MAXBUF) GO TO 300
	BUFFER(BRECPTR+FLINK) = BUFFER(I)
	BUFFER(BRECPTR+BKTLOWBND) = BKTLOW(IBKT)
	BUFFER(BRECPTR+BKTHIBND) = BKTHIGH(IBKT)
	BUFFER(BRECPTR+COUNT) = 0
	BUFFER(BRECPTR+BUCKETNUM) = IBKT
	BUFFER(I) = BRECPTR*4
	BRECPTR = BRECPTR + BKTRECSIZ
   80	CONTINUE
C
C	***NOW CHANGE ANY REMAINING ZEROED INDEX TABLE ENTRIES TO POINT TO
C	***THE FIRST BUCKET RECORD, THE ONE WITH THE INVERTED ADDRESS RANGE.
	DO 90 I = INDXPTR, INDXPTR+GRPNBKTS(IGRP)-1
	IF(BUFFER(I) .EQ. 0) BUFFER(I) = BUFFER(HDRBRECPTR)
   90	CONTINUE
C
C	***INCREMENT THE GROUP RECORD POINTER AND THE INDEX TABLE POINTER FOR
C	***THE NEXT BUCKET GROUP.  THEN LOOP FOR THAT NEXT GROUP.
	GRPPTR = GRPPTR + GRPRECSIZ
	INDXPTR = INDXPTR + GRPNBKTS(IGRP)
  100	CONTINUE
C
C	***ALL BUCKET GROUPS HAVE BEEN TAKEN CARE OF.  NOW BUILD A LAST GROUP
C	***RECORD OF ALL ZEROES AS A TERMINATOR.
	DO 120 I=1,GRPRECSIZ
  120	BUFFER(GRPPTR + I - 1) = 0
C
C	***GET THE POINTER TO THE START OF THE BUCKET NAME TABLE AND COMPLETE
C	***THE REST OF THE FILE HEADER RECORD.
	NAMPTR = BRECPTR
	BUFFER(HDRNAMPTR) = NAMPTR*4
	BUFFER(HDRNXTPTR) = (NAMPTR + NBKTS*NAMRECSIZ)*4
	IF(NAMPTR + NBKTS*NAMRECSIZ .GT. MAXBUF) GO TO 300
C
C	***FINALLY COPY ALL BUCKET NAMES (THE APPROPRIATE PROGRAM UNIT NAMES)
C	***AND THE CORRESPONDING BASE ADDRESSES TO THE BUCKET NAME TABLE.
	DO 140 IBKT=1,NBKTS
	BUFFER(NAMPTR) = BKTBASE(IBKT)
	NAMPTR = NAMPTR + 1
	CHRNAME = UNITTBL(BKTNAMPTR(IBKT))
	DO 140 I = 1, NAMRECSIZ-1
	BUFFER(NAMPTR) = INTNAME(I)
	NAMPTR = NAMPTR + 1
  140	CONTINUE
C
C	***THE BUFFER IS COMPLETED--CREATE A NEW BUCKET FILE AND WRITE OUT THE
C	***BUFFER TO THAT FILE.
	CALL PME_CLOSE(BUFFER)
	RETURN
C
C
C	***HANDLE THE BUFFER OVERFLOW ERROR
  300	PRINT 310
  310	FORMAT('0*** Error:  Too many sampling buckets specified ***'/
     1	       ' ***         Hence no Bucket File can be built   ***')
	ERRFLG = .TRUE.
	RETURN
	END

