$ ! ******************************************************************
$ !
$ ! PMEKITBLD.COM - Create an installation kit for the PME Performance
$ !		    Measurement and Evaluation package.
$ !
$ !		    Assumes kit components to be in DB1:[BEANDER.PME].
$ !
$ ! ******************************************************************
$ !
$ !
$ ! Start by dismounting the standard system floppy and getting the
$ ! first PME floppy (for images, objects, and documentation) mounted.
$ ! This floppy can later be installed with the standard VMS update
$ ! procedure.
$ !
$ TYPE SYS$INPUT:
  Start of PME kit build procedure.
$ ASSIGN DB1:[BEANDER.PME] PME$KIT:
$ DISMOUNT DXA1:
$ TYPE SYS$INPUT:

 Place the first PME floppy in the drive.

$ ALLOCATE	DXA1:
$10:
$ INQUIRE R "Are you ready to continue?"
$ IF .NOT. R THEN GOTO 10
$ SHOW DAYTIME
$ INITIALIZE	DXA1: PME
$ MOUNT		DXA1: PME
$ CREATE/DIR	DXA1:[SYSUPD]
$ !
$ COPY		PME$KIT:PMEBUILD.EXE	DXA1:[SYSUPD]
$ COPY		PME$KIT:PMEHISTO.EXE	DXA1:[SYSUPD]
$ COPY		PME$KIT:PME.OBJ		DXA1:[SYSUPD]
$ COPY		PME$KIT:PMECLOCK.OBJ	DXA1:[SYSUPD]
$ COPY		PME$KIT:PMETRACE.OBJ	DXA1:[SYSUPD]
$ COPY		PME$KIT:PMEDOC.DOC	DXA1:[SYSUPD]
$ COPY		PME$KIT:PMEINSTAL.COM	DXA1:[SYSUPD]PME.COM
$ !
$ DIRECTORY DXA1:[SYSUPD]
$ SET PROTECTION DXA1:[SYSUPD]*.*/PROTECTION=(SYSTEM:RWED)
$ !
$ !
$ ! Dismount the first PME floppy and get the second one mounted.  This
$ ! second PME floppy gets all the PME source files.  The VMS update
$ ! procedure cannot be used with the second floppy.
$ !
$ DISMOUNT  DXA1:
$ SHOW DAYTIME
$ TYPE SYS$INPUT:

 Now remove the first PME floppy (images, objects, documentation) and
 and put the second PME floppy (sources) in the drive.

$20:
$ INQUIRE R "Are you ready to continue?"
$ IF .NOT. R THEN GO TO 20
$ SHOW DAYTIME
$ INITIALIZE	DXA1: PMESOURCE
$ MOUNT		DXA1: PMESOURCE
$ CREATE/DIR	DXA1:[PMESOURCE]
$ !
$ COPY		PME$KIT:*.COM	DXA1:[PMESOURCE]
$ COPY		PME$KIT:*.FOR	DXA1:[PMESOURCE]
$ COPY		PME$KIT:*.MAR	DXA1:[PMESOURCE]
$ COPY		PME$KIT:*.RNO	DXA1:[PMESOURCE]
$ !
$ !
$ ! The source floppy is now done--restore the standard system floppy.
$ !
$ DISMOUNT  DXA1:
$ SHOW DAYTIME
$ TYPE SYS$INPUT:

 Now remove the PME floppy and put the standard console floppy back.

$30:
$ INQUIRE R "Are you ready to continue?"
$ IF .NOT. R THEN GOTO 30
$ MOUNT/SYSTEM/FOR/PROT=(SYSTEM:RWLP) DXA1: CONSOLE
$ TYPE SYS$INPUT:
  End of PME kit build procedure.
$ !
$ ! End of Kit Build process.
$ !
$ ! ********************************************************************
