!	THE FOLLOWING IS A PROCEDURE USED TO INVOKE TECO.
!
!	This procedure has the advantage, over direct invocation,
!	that it will accept, as part of the invoking string, the name
!	of the file to be edited, the word "keep" and a number to be 
!	used as a keep count for purging the file after editing.
!
!	EG: TEC [FILENAME.EXT [KEEP N]]
!	(where TEC:==SYSCMD:TECO)
!
!	The filename and the keep count are stored in the global
!	symbols OLD_SPEC and KEEP_VERSIONS respectively.  This means
!	that on subsequent invocations of teco the filename and the
!	keep count need be specified only if a change is desired.
!	Further, if it is desired to default to a particular filename
!	or keep count then these globals can be defined in the login
!	procedure.
!
!	by using this file and EDI.COM, TECO and EDI may be used
!	interchangably with the same conditions prevailing.
!
!		Mr. H. E. Chadwick
!		Department 22810
!		Western Electric Co., Inc.
!		6200 East Broad Street
!		Columbus, Ohio 43213
!			614-868-2093
!
!
$ IF ("''P2'".EQS."KEEP".OR."''P2'".EQS."") THEN GOTO P2_OK
$ WRITE SYS$OUTPUT "INVALID ""KEEP"" PARAMETER"
$ EXIT
$ P2_OK:
$ EDIT_MODE:=EW
$ MACRO_END:=""
$ OPEN/WRITE MACRO_OUT TECO.TEC
$ WRITE MACRO_OUT "EIWE$SYS$PGMS:VT52.TEC"
$ IF ("''P1'".EQS."") THEN GOTO CHECK_OLD_SPEC
$ USE_P1_SPEC:
$ OLD_SPEC:=='P1'
$ CHECK_OLD_SPEC:
$ IF ("''OLD_SPEC'".NES."") THEN GOTO USE_OLD_SPEC
$ INQUIRE P1 $_File       
$ GOTO USE_P1_SPEC
$ NEW_FILE_MESSAGE:
$ WRITE SYS$OUTPUT "CREATING NEW FILE"
$ GOTO WRITE_FILE_SPEC
$ USE_OLD_SPEC:
$ ON WARNING THEN GOTO NEW_FILE_MESSAGE
$ ASSIGN/USER_MODE NL: SYS$ERROR:
$ OPEN/READ TEST_FOR_EXISTANCE 'OLD_SPEC'
$ EDIT_MODE:=EB
$ MACRO_END:="A"
$ CLOSE TEST_FOR_EXISTANCE
$ WRITE_FILE_SPEC:
$ ON WARNING THEN CONTINUE
$ ON SEVERE_ERROR THEN EXIT
$ FILE_SPEC:='EDIT_MODE''OLD_SPEC'
$ WRITE MACRO_OUT FILE_SPEC
$ WRITE MACRO_OUT "MI"
$ WRITE MACRO_OUT MACRO_END
$ CLOSE MACRO_OUT
$ ASSIGN/USER_MODE TT: SYS$INPUT:
$ ASSIGN/USER_MODE TT: SYS$OUTPUT:
$ MCR TEC
$ IF (P3.EQS."") THEN GOTO TRY_OLD_KEEP
$ KEEP_VERSIONS=='P3'
$ TRY_OLD_KEEP:
$ KEEP_VERSIONS=='KEEP_VERSIONS'+0
$ IF ('KEEP_VERSIONS'.LE.0)THEN GOTO THE_END
$ PURGE/KEEP='KEEP_VERSIONS' 'OLD_SPEC'
$ THE_END:
$ CLR
$ DEL TECO.TEC;0
